// handle APNS notifications for iOS
function onNotificationAPN(e) {
    //alert("onNotificationAPN");
    //alert(e);
    if (e.alert) {
        navigator.notification.alert(e.alert);
    }
    if (e.badge) {
        pushNotification.setApplicationIconBadgeNumber(successHandler, e.badge);
    }
}
            
// handle GCM notifications for Android
function onNotificationGCM(e) {
    //alert(e.event);
    //EVENT -> RECEIVED:' + e.event +');
    switch( e.event ){
        case 'registered':
            if ( e.regid.length > 0 ){
                //REGISTERED -> REGID:' + e.regid +
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                //alert("regID = " + e.regid);

                var url = window.IPServidor + '/api/buonjobs/device/gcm/';

                var modelUser = new window.User(JSON.parse(window.localStorage.getItem("user")).user);
              
                var registrationValues = ({
                    registration_id: e.regid
                });

               // alert("abans peticio ajax");

                $.ajax({
                    url:url,
                    type:'POST',
                    dataType:"json",
                    //beforeSend : setHeader,
                    beforeSend: sendAuthentication,
                    /*username: modelUser.get("username"),
                    password: modelUser.get("clau"),*/
                    contentType:"application/json",
                    data: JSON.stringify(registrationValues),
                    success:function (data) {
                       // alert('success registered');
                        //alert(JSON.stringify(data));
                    	window.localStorage.setItem("deviceid", JSON.stringify(data.id));
                    },
                    error: function (errormessage) {
                        //alert(JSON.stringify(errormessage));
                        loadingSpinner("off");
                    }
                });
            }
        break;
                    
        case 'message':
            // if this flag is set, this notification happened while we were in the foreground.
            // you might want to play a sound to get the user's attention, throw up a dialog, etc.

            if (e.foreground){
                if($("#menu").length>0){

                    $.ajax({
                        url: window.IPServidor + '/api/buonjobs/notificacio/',
                        type:'GET',
                        dataType:'json',
                        contentType:'application/json',
                        success:function (missatgeResposta) {
                            if(typeof modelUser.cif != "undefined"){
                                $('#nA p').text("0");
                                $('#nR p').text("0");
                                $('#nV p').text("0");
                                $('#nO p').text("0");
                                
                            }else{
                                $('#nP p').text("0");
                            }
                            var modelUser = JSON.parse(window.localStorage.getItem("user"));
                            var quantesNotificacions = missatgeResposta.objects.length;

                            if(quantesNotificacions>0){
                                //alert("primera notificacio!");
                                var notificacions = {
                                    "data": []
                                };
                                var number;
                                
                                for(var i=0;i<quantesNotificacions;i++) {                  
                                    var valuesNotifications = ({
                                        id: missatgeResposta.objects[i].id,
                                        idNotificacio: missatgeResposta.objects[i].idTipus,
                                        messageType: missatgeResposta.objects[i].tipus
                                    });
                                    notificacions.data.push(valuesNotifications);

                                    if(typeof modelUser.cif != "undefined"){
                                        if(missatgeResposta.objects[i].tipus==2){
                                            $('#nA').css('display','block');
                                            number = parseInt($('#nA p').text())+1;
                                            $('#nA p').text(number);
                                        }else if(missatgeResposta.objects[i].tipus==3){
                                            $('#nR').css('display','block');
                                            number = parseInt($('#nR p').text())+1;
                                            $('#nR p').text(number);
                                        }else if(missatgeResposta.objects[i].tipus==4){
                                            $('#nV').css('display','block');
                                            number = parseInt($('#nV p').text())+1;
                                            $('#nV p').text(number);
                                        }
                                        else if(missatgeResposta.objects[i].tipus==5){
                                            $('#nO').css('display','block');
                                            number = parseInt($('#nO p').text())+1;
                                            $('#nO p').text(number);
                                        }


                                    }else{
                                        if(missatgeResposta.objects[i].tipus==0){
                                            $('#nP').css('display','block');
                                            number = parseInt($('#nP p').text())+1;
                                            $('#nP p').text(number);
                                        }
                                    }
                                }
                                window.localStorage.setItem("notifications", JSON.stringify(notificacions));
                            }
                        },
                        error: function (errormessage) {
                            //alert("peticio recurs llistat ofertes fail");
                            loadingSpinner("off");
                        }
                    });
                    //$("#menu").show();
                }
                
                   //INLINE NOTIFICATION-
            }else{  // otherwise we were launched because the user touched a notification in the notification tray.
                if (e.coldstart){
                    //--COLDSTART NOTIFICATION--
                    //alert("coldstart");
                }else{
                    //BACKGROUND NOTIFICATION-
                    
                }
            }
           
        break;
                    
        case 'error':
            //alert(e.msg); 
        break;
              
        default:
            //alert('default');
        break;
    }
}
function tokenHandler (result) {
    //alert('token');
    //token: '+ result +
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
    //peticio a API REST per IOS
    var url = window.IPServidor + '/api/buonjobs/device/apns/';

    var modelUser = new window.User(JSON.parse(window.localStorage.getItem("user")).user);

    var registrationValues = ({
        registration_id: result
    });

    var datainfo =  JSON.stringify(registrationValues);
    $.ajax({url: url, beforeSend: sendAuthentication,contentType:"application/json",data:datainfo,dataType: "json", type: "POST"})
    .done(function (data) {
    	//alert('done');
    	window.localStorage.setItem("deviceid", JSON.stringify(data.id));
    })
    .fail(function (error) {
    	//alert(JSON.stringify(error));
        loadingSpinner("off");
    });
    
    /*$.ajax({
        url:url,
        type:'POST',
        dataType:"json",
        beforeSend: sendAuthentication,
        contentType:"application/json",
        data: JSON.stringify(registrationValues),
        success:function (response) {
        	JSON.stringify(response);
        	
        	JSON.stringify(response.id);
        	
        	window.localStorage.setItem("deviceid", JSON.stringify(response.id));
        },
        error: function (errormessage) {
            
        }
    });*/
}
function successHandler (result) {
    //alert('success'+result);
    //success:'+ result +
}
function errorHandler (error) {
    //alert('error'+error);
    //error:'+ error +'
}