window.BuscarDesdeProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.inicialitza, 0);
        return this;
    },

    events:{
        'click #registerClientButton':'vesABuscarOfertes',
        'click #back_boto':'vesAPantallaAnterior'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },

    inicialitza: function ( e ) {
        errorMap = true;
        window.localStorage.removeItem("desDaqui");
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $(this).removeClass('tapped');
            }, 1000);
        });

        var height = $('.loadingMap').height();
        var mapHeight = $('#map').height();

        $('.loadingMap').css({'top':(mapHeight-height)/2+'px'});

        $('#radiBuscar').text('radio 1 km');
        window.radi=1;

        $("#slider").slider({
            min: -20000,
            max: -1000,
            value: -1000,
            step: 1000,
            selection: 'after',
            tooltip: 'hide',
            orientation: 'vertical'
        }).on('slide', function(ev){
            $('#distancia').val(-ev.value);
            window.radi = -ev.value/1000;
            $('#radiBuscar').text('radio '+-ev.value/1000+' km');
        });
        loadingSpinner("off");
        
        navigator.geolocation.getCurrentPosition(success, error, { maximumAge: 5000, timeout: 20000, enableHighAccuracy: true });

        function success(position) {
            $('.btnHover2').on('touchstart', function(e){
                $(this).addClass('tapped');
            });
            $('.btnHover2').on('touchend', function(e){
                setTimeout(function(){
                    $(this).removeClass('tapped');
                }, 1000);
            });
            window.localStorage.setItem("latitud", position.coords.latitude);
            window.localStorage.setItem("longitud", position.coords.longitude);
            
            var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
            var myOptions = {
                zoom: 11,
                center: latlng,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            };
            var map = new google.maps.Map(document.getElementById("map"), myOptions);

            var marker = new google.maps.Marker({
                position: latlng, 
                map: map, 
                title:"You are here! (at least within a "+position.coords.accuracy+" meter radius)"
            });

            var options = {
                strokeColor: '#800000',
                strokeOpacity: 1.0,
                strokeWeight: 1,
                fillColor: '#C64D45',
                fillOpacity: 0.5,
                map: map,
                center: latlng,
                radius: 1000
            };

            var circle = new google.maps.Circle(options);
            $('#radiBuscar').text('radio 1 km');
            window.localStorage.setItem("radi", 1);

            $("#slider").on('slide', function(ev){
                $('#distancia').val(-ev.value);
                circle.set('radius', -ev.value);
                window.localStorage.setItem("radi", -ev.value/1000);
                $('#radiBuscar').text('radio '+-ev.value/1000+' km');
            });
            $('.loadingMap').css({'display':'none'});
            errorMap = false;
        }
        function error(msg) {
          	customAlert("El sistema no puede detectar su localización actual. Compruebe que su dispositivo móvil tiene activada la opción de detectar su ubicación mediante su conexión a internet",0,10000,"",3,false);
            errorMap = true;
            $('.loadingMap').css({'display':'none'});
            $('.errorMap').css({'display':'block'});
            var height = $('.errorMap').height();
            var mapHeight = $('#map').height();
            $('.errorMap').css({'top':(mapHeight-height)/2+'px'});
            loadingSpinner("off");
        }
    },

    vesAPantallaAnterior: function ( e ) {
        loadingSpinner("on");
        window.history.back();
    },

    vesABuscarOfertes: function( e ) {
        e.preventDefault();
        if(!errorMap){
            loadingSpinner("on");
            window.localStorage.setItem("desDaqui", true);
            app.navigate('verOfertasProfesional', true);
            if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button BuscarDesDaqui - Buscar Des d'Aqui", "Click", "Buscar Des d'Aqui", 1);
            }
        }
    }
});
