window.GestioContaClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #boto_registre_client':'peticioRegistreServer',
        'click #eliminarClient':'eliminarClient',
    	'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
        
    
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },

    renderSlider: function ( e ) {
        
       
    	$('#formulariLoginClient').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            loadingSpinner("on");

            if($("#formulariLoginClient").valid()){
                comprovaDades();
            }else{
                loadingSpinner("off");
            }
            
            function comprovaDades(){
                var clientModel = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                var formData = {};

                $( '#formulariLoginClient div' ).children( 'input' ).each( function( i, el ) {
                    if( $( el ).val() != '' ){
                        formData[ el.id ] = $( el ).val();
                    }
                });

                var formUserValues = ({
                    id: clientModel.get("user").id,
                    usuari: formData['usuari'],
                    clau: formData['clau'],
                    correu: formData['correu']
                });
                
                var modelUser = new window.User(formUserValues);
                modelUser.url = window.IPServidor + clientModel.get("user").resource_uri;
                modelUser.save( {} , {
                    beforeSend: sendAuthentication,
                    error: function(model, response) {
                        customAlert(response.responseText,1,0,"",3,false);
                        loadingSpinner("off");
                    },
                    success: function(model, response) {
                        var userURIAPI = response.resource_uri;
                        
                        var authUserValues = ({
                            username:  $("#usuari").val(),
                            clau:  $("#clau").val()
                        });
                        window.localStorage.setItem("auth", JSON.stringify(authUserValues));

                        var direccions = [];
                        for(var i=0;i<clientModel.get("direccio").length;i++){
                            direccions.push(clientModel.get("direccio")[i].resource_uri);
                        }
                        
                        ///////////////////Ara fer la peticio pel client, ara he fet la del user
                        var formClientValues = ({
                            id: clientModel.get("id"),
                            user: userURIAPI,
                            nom: formData['nom'],
                            telefon: formData['telefon'],
                            direccio: direccions
                        });

                        var modelClient = new window.Client(formClientValues);
                        modelClient.url = window.IPServidor + clientModel.get("resource_uri");
                        modelClient.save( {} , {
                            beforeSend: sendAuthentication,
                            error: function(model, response) {
                                customAlert(response.responseText,1,0,"",3,false);
                                loadingSpinner("off");
                            },
                            success: function(model, response) {
                                window.localStorage.setItem("user", JSON.stringify(model));
                                //window.history.back();
                                customAlert("Cuenta cliente modificada!",0,2000,"",1,false);
                                loadingSpinner("off");
       
                                if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                    gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarUsuari - Gestio Client", "Click", "Gestio Client", 1);
                                }
                            }
                        });
                    }
                });
            }
        });

        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));

        $('#usuari').val(modelClient.get("user").username);
        $('#clau').val(modelClient.get("user").clau);
        $('#clau2').val(modelClient.get("user").clau);
        $('#correu').val(modelClient.get("user").email);
        $('#nom').val(modelClient.get("nom"));
        $('#telefon').val(modelClient.get("telefon"));

        //Definim les normes a validar
        $("#formulariLoginClient").validate({
            rules: {
                nom: "required",
                usuari: {
                    required: true,
                    minlength: 2
                },
                clau: {
                    required: true,
                    minlength: 5
                },
                clau2: {
                    required: true,
                    minlength: 5,
                    equalTo: "#clau"
                },
                correu: {
                    required: true,
                    email: true
                },
                telefon: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });

        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        loadingSpinner("off");
        window.history.back();
    },

    peticioRegistreServer: function( e ) {
        e.preventDefault();
        loadingSpinner("on");

        if($("#formulariLoginClient").valid()){
            comprovaDades();
        }else{
            loadingSpinner("off");
        }
        
        function comprovaDades(){
            var clientModel = new window.Client(JSON.parse(window.localStorage.getItem("user")));
            var formData = {};

            $( '#formulariLoginClient div' ).children( 'input' ).each( function( i, el ) {
                if( $( el ).val() != '' ){
                    formData[ el.id ] = $( el ).val();
                }
            });

            var formUserValues = ({
                id: clientModel.get("user").id,
                usuari: formData['usuari'],
                clau: formData['clau'],
                correu: formData['correu']
            });
            
            var modelUser = new window.User(formUserValues);
            modelUser.url = window.IPServidor + clientModel.get("user").resource_uri;
            modelUser.save( {} , {
                beforeSend: sendAuthentication,
                error: function(model, response) {
                	customAlert(response.responseText,1,0,"",3,false);
                    loadingSpinner("off");
                },
                success: function(model, response) {
                    var userURIAPI = response.resource_uri;
                    
                    var authUserValues = ({
                        username:  $("#usuari").val(),
                        clau:  $("#clau").val()
                    });
                    window.localStorage.setItem("auth", JSON.stringify(authUserValues));

                    var direccions = [];
                    for(var i=0;i<clientModel.get("direccio").length;i++){
                        direccions.push(clientModel.get("direccio")[i].resource_uri);
                    }
                    
                    ///////////////////Ara fer la peticio pel client, ara he fet la del user
                    var formClientValues = ({
                        id: clientModel.get("id"),
                        user: userURIAPI,
                        nom: formData['nom'],
                        telefon: formData['telefon'],
                        direccio: direccions
                    });

                    var modelClient = new window.Client(formClientValues);
                    modelClient.url = window.IPServidor + clientModel.get("resource_uri");
                    modelClient.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function(model, response) {
                        	customAlert(response.responseText,1,0,"",3,false);
                            loadingSpinner("off");
                        },
                        success: function(model, response) {
                            window.localStorage.setItem("user", JSON.stringify(model));
                            //window.history.back();
                            customAlert("Cuenta cliente modificada!",0,2000,"",1,false);
                            loadingSpinner("off");
   
                            if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarUsuari - Gestio Client", "Click", "Gestio Client", 1);
                            }
                        }
                    });
                }
            });
        }
    },

    eliminarClient: function ( e ) {
        e.preventDefault();

        $('.customAlert').css('width', $(window).width() + 'px', 'important');

        $('.alertMessage').text("Seguro que quieres eliminar la cuenta?");
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    loadingSpinner("on");
                    closePage();
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });

        function closePage(){
            var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
            var clientValues = ({
                id: modelClient.get("id")
            });
            
           
            var clientModel = new window.Client(clientValues);
            clientModel.url = window.IPServidor + modelClient.get("resource_uri");
            clientModel.destroy({
                beforeSend: sendAuthentication,
                error: function() {
                    customAlert("Ha ocurrido un error dando de baja el cliente!",0,2000,"",2,false);
                    loadingSpinner("off");
                },
                success: function() {
                    customAlert("Se ha dado de baja el cliente!",0,2000,"",5,true);
                    if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                        gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button EliminarUsuari - Gestio Client", "Click", "Gestio Client", 1);
                    }
                }
            });
        }
    }
   
});
