window.GestioContaProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #boto_registre_client':'peticioRegistreProfesionalServer',
        'click #boto_afegir_foto':'getFoto',
        'click #boto_afegir_logo':'canviarBotonsAfegirLogo',
        'click #boto_afegir_foto_certificat':'canviarBotonsAfegirCertificat',
        'click #boto_afegir_fotos':'canviarBotonsAfegirFotos',
        'click #boto_mapa':'addMarkerForAddress',
        'click #boto_categoria':'mostraCategoria',
        'click #categoria':'fixaCategoria',
        'click #refreshMap':'addMarkerForAddress',
        'click #eliminarProfesional':'eliminarProfesional',
        'click #deletePhoto':'eliminaFoto',
        'click #deleteLogo':'eliminaLogo',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'click #comments3':'comments3',
        'click #comments4':'comments4',

        'click #ampliar':'ampliar',
    	'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    
    
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },

    ampliar: function(e){
        showImage(e.currentTarget.attributes[1].value);
    },

    renderSlider: function ( e ) {

        $('#formulariLoginProfesional').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            loadingSpinner("on");
    
            if($("#formulariLoginProfesional").valid()){
                if(categoria=="undefined"){
                    $('html, body').animate({
                        scrollTop: $('.parent').offset().top
                    }, 1000);
                    $('#errorVerificarCategoria').css({'display':'block'});
                    loadingSpinner("off");
                }else{
                    if(!booleaGeneral){
                        $('html, body').animate({
                            scrollTop: $('.titleRegistre').offset().top
                        }, 1000);
                        $('#errorVerificarMapa').css({'display':'block'});
                        loadingSpinner("off");
                    }else{
                        comprovaDades();
                    }
                }
            }else{
                loadingSpinner("off");
            }

            function comprovaDades(){
                if(deleteFotos.length>0){
                    var successFotos = 0;
                    for(var i=0;i<deleteFotos.length;i++){

                    	var fotoProfessionalValues = ({
                            id: deleteFotos[i]
                        });
                    	var modelProfesionalFoto = new window.FotoProfesional(fotoProfessionalValues);
                        modelProfesionalFoto.url = window.IPServidor + '/api/buonjobs/fotoProfesional/'+deleteFotos[i]+'/';
                        modelProfesionalFoto.destroy({
                            beforeSend: sendAuthentication,
                            success: function(){
                                successFotos++;
                                if(successFotos==deleteFotos.length){
                                    if(deleteCertificats.length>0){
                                        successFotos=0;
                                        for(var i=0;i<deleteCertificats.length;i++){

                                        	var fotoCertificatValues = ({
                                                id: deleteCertificats[i]
                                            });
                                        
                                        	var modelProfesionalCertificat = new window.AcreditacioProfesional(fotoCertificatValues);
                                            modelProfesionalCertificat.url = window.IPServidor + '/api/buonjobs/acreditacioProfesional/'+deleteCertificats[i]+'/';
                                            modelProfesionalCertificat.destroy({
                                                beforeSend: sendAuthentication,
                                                success: function(){
                                                    successFotos++;
                                                    if(successFotos==deleteCertificats.length){
                                                        keepGoing();
                                                    }
                                                }
                                            });
                                        }
                                    }else{
                                        keepGoing();
                                    }
                                }
                            }
                        });
                    }
                }else if(deleteCertificats.length>0){
                    var successFotos=0;
                    for(var i=0;i<deleteCertificats.length;i++){

                    	var fotoCertificatValues = ({
                            id: deleteCertificats[i]
                        });
                    
                    	var modelProfesionalCertificat = new window.AcreditacioProfesional(fotoCertificatValues);
                        modelProfesionalCertificat.url = window.IPServidor + '/api/buonjobs/acreditacioProfesional/'+deleteCertificats[i]+'/';
                        modelProfesionalCertificat.destroy({
                            beforeSend: sendAuthentication,
                            success: function(){
                                successFotos++;
                                if(successFotos==deleteCertificats.length){
                                    keepGoing();
                                }
                            }
                        });
                    }
                }else{
                    keepGoing();
                }

                function keepGoing(){

                    var profesionalModel = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
                    var direccioValues = ({
                        id: profesionalModel.get("direccio").id,
                        numero: $("#numero").val(),
                        carrer: $("#carrer").val(),
                        ciutat: $("#ciutat").val(),
                        pais: $("#pais").val(),
                        codipostal: $("#codiPostal").val(),
                        latitud: returnedValue.lat(),
                        longitud: returnedValue.lng()
                    });

                    var formUserValues = ({
                        id: profesionalModel.get("user").id,
                        usuari:  $("#usuari").val(),
                        clau:  $("#clau").val(),
                        correu:  $("#correu").val()
                    });

                    var modelDireccio = new window.Direccio (direccioValues);
                    modelDireccio.url = window.IPServidor + profesionalModel.get("direccio").resource_uri;
                    // Backbone.Model.save returns a jqXHR object
                    modelDireccio.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function(model, response) {
                            customAlert(response.responseText,1,0,"",3,false);
                            loadingSpinner("off");
                        },
                        success: function(model, response) {
                            var direccioAPIURL = response.resource_uri;

                            var modelUser = new window.User(formUserValues);
                            modelUser.url = window.IPServidor + profesionalModel.get("user").resource_uri;
                            //alert(modelUser.url);

                            modelUser.save( {} , {
                                beforeSend: sendAuthentication,
                                error: function(model, response) {
                                    customAlert(response.responseText,1,0,"",3,false);
                                    loadingSpinner("off");
                                },
                                success: function(model, response) {
                                    var userURIAPI = response.resource_uri;

                                    //he de guardar nou usuari per Basic Authentication
                                    var authUserValues = ({
                                        username:  $("#usuari").val(),
                                        clau:  $("#clau").val()
                                    });
                                    window.localStorage.setItem("auth", JSON.stringify(authUserValues));

                                    var formProfesionalValues = ({
                                        id: profesionalModel.get("id"),
                                        user: userURIAPI,
                                        nom: $("#nom").val(),
                                        telefon: $("#telefon").val(),
                                        empresa:  $("#empresa").val(),
                                        activitat: categoria,
                                        descripcio: $("#descripcio").val(),
                                        logotip: window.fotoLogoAPIURL,
                                        direccio: direccioAPIURL,
                                        acreditacions: window.fotoCertificatAPIURL,
                                        imatges: window.fotoProfesionalAPIURL,
                                        cif: $("#CIF").val(),
                                        distanciaTreballs: $("#distancia").val()
                                    });

                                   //alert(JSON.stringify(formProfesionalValues));

                                    var modelProfesional = new window.Profesional (formProfesionalValues);
                                    modelProfesional.url = window.IPServidor + profesionalModel.get("resource_uri");

                                    modelProfesional.save( {} , {
                                        beforeSend: sendAuthentication,
                                        error: function(model, response) {
                                            customAlert(response.responseText,1,0,"",3,false);
                                            loadingSpinner("off");
                                        },
                                        success: function(model, response) {
                                            var modelProfesional = new window.Profesional();
                                            modelProfesional.url = window.IPServidor + profesionalModel.get("resource_uri");
                                            modelProfesional.fetch({
                                                beforeSend: sendAuthentication,
                                                error: function(model, response) {
                                                    customAlert(response.responseText,1,0,"",3,false);
                                                    loadingSpinner("off");
                                                },
                                                success: function (model, response) {
                                                    var formUserValues = ({
                                                        id: model.get("user").id,
                                                        username:  $("#usuari").val(),
                                                        clau:  $("#clau").val(),
                                                        email:  model.get("user").email,
                                                        resource_uri: model.get("user").resource_uri
                                                    });
                                                    model.set({user: formUserValues});
                                                    window.localStorage.setItem("user", JSON.stringify(model));
                                                    //alert('abans custom alert modifica');
                                                    customAlert("Cuenta profesional modificada!",0,2000,"",1,false);
                                                    loadingSpinner("off");
                                                    //alert('despres custom alert modifica');
                                                     
                                                    // window.history.back();
                                                    if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                                        gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarUsuari - Gestio Professional", "Click", "Gestio Professional", 1);
                                                    }
                                                }
                                            });
                                        }
                                    });
                                }
                            });
                        }
                    });
                }
            }
        });
        
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        timeFotos=1;
        timeAcreditacio=1;

        var modelProfesional = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
        window.fotoCertificatAPIURL = [];
        window.fotoProfesionalAPIURL = [];
        window.deleteFotos = [];
        window.deleteCertificats = [];

        //Main Swiper
        //alert(JSON.stringify(modelProfesional));

        swiperDyn = $('#galeria').swiper({
            pagination:'.pagination-sd'
        });
        if(modelProfesional.get("imatges").length>0){
            $('#galeria').css({'display':'block'});
            //alert('tenim imatges');
            for(var i=0;i<modelProfesional.get("imatges").length;i++){
            	var imatge = modelProfesional.get("imatges")[i].imatges;
            	//alert(imatge);
            	var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+imatge+'"/>');
                newSlide.append();
                window.fotoProfesionalAPIURL.push(modelProfesional.get("imatges")[i].resource_uri);
                timeFotos++;
            }
        }
        //alert('despres imatges');
        swiperDynAcred = $('#galeriaAcred').swiper({
            pagination:'.pagination-sdAcred'
        });
        if(modelProfesional.get("acreditacions").length>0){
            $('#galeriaAcred').css({'display':'block'});
            //alert('tenim acreditacions');
            for(var i=0;i<modelProfesional.get("acreditacions").length;i++){
                var imatge = modelProfesional.get("acreditacions")[i].acreditacionsProfesionals;
               // alert(imatge);
            	var newSlide = swiperDynAcred.createSlide('<img id="ampliar" src="'+imatge+'"/>');
                newSlide.append();
                window.fotoCertificatAPIURL.push(modelProfesional.get("acreditacions")[i].resource_uri);
                timeAcreditacio++;
            }
        }
       
        if(modelProfesional.get("logotip")!=null){
        	var logourl = modelProfesional.get("logotip");
        	var logolast = logourl.lastIndexOf('?');
        	var sliced = logourl.slice(0,logolast);
        	var len = sliced.length;
        	var lastslash = sliced.lastIndexOf('/');
        	window.fotoLogoAPIURL = sliced.substr(lastslash+1,len);
            $("#fotoLogo").attr("src",modelProfesional.get("logotip"));
            $('#contenidorFotoLogo').css({'display':'block'});
        }
        else{
            window.fotoLogoAPIURL="";
        }


        categoria=modelProfesional.get("activitat");
        $("a[data-categoria='reparacions']").text(categoria);
        $('#dropdown').height($('#DropContent a').outerHeight(true));

        //console.log(modelProfesional);
        
        $('#usuari').val(modelProfesional.get("user").username);
       

        $('#clau').val(modelProfesional.get("user").clau);
        $('#clau2').val(modelProfesional.get("user").clau);
        $('#correu').val(modelProfesional.get("user").email);
        $('#nom').val(modelProfesional.get("nom"));
        $('#empresa').val(modelProfesional.get("empresa"));
        $('#telefon').val(modelProfesional.get("telefon"));
        $('#CIF').val(modelProfesional.get("cif"));
        $('#ciutat').val(modelProfesional.get("direccio").ciutat);
        $('#codiPostal').val(modelProfesional.get("direccio").codipostal);
        $('#carrer').val(modelProfesional.get("direccio").carrer);
        $('#numero').val(modelProfesional.get("direccio").numero);
        $('#descripcio').text(modelProfesional.get("descripcio"));
        $('#distancia').val(modelProfesional.get("distanciaTreballs"));

        booleaGeneral=false;
        dropdown=false;
        $("#slider").slider({
            min: 1,
            max: 100,
            value: parseInt($('#distancia').val()),
            tooltip: 'hide'
        }).on('slide', function(ev){
            $('#distancia').val(ev.value);
        });
        $('#distancia').change( function(){
            $("#slider").slider('setValue', $('#distancia').val());
        });
        
        //Definim les normes a validar
        $("#formulariLoginProfesional").validate({
            rules: {
                nom: "required",
                usuari: {
                    required: true,
                    minlength: 2
                },
                clau: {
                    required: true,
                    minlength: 5
                },
                clau2: {
                    required: true,
                    minlength: 5,
                    equalTo: "#clau"
                },
                correu: {
                    required: true,
                    email: true
                },
                telefon: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        $("#formulariPosicio").validate({
            rules: {
                ciutat: "required",
                carrer: "required",
                codiPostal: {
                    required: true,
                    digits: true
                },
                numero: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        //this.addMarkerForAddress();
        //alert('abans out marker');
        outAddMarker();
        //alert('despres out marker');

        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        loadingSpinner("on");
        window.history.back();
    },

    eliminaLogo: function ( e ) {
        $('.customAlert').css('width', $(window).width() + 'px', 'important');
        $('.alertMessage').text("Seguro que quieres eliminar el logotipo de profesional?");
                  
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('#contenidorFotoLogo').css({'display':'none'});
                    window.fotoLogoAPIURL = "";
                    deleteLogo = true;
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });
    },

    eliminaFoto: function ( e ) {
        $('.customAlert').css('width', $(window).width() + 'px', 'important');
        if($(e.currentTarget).attr('data-delete')=="photos"){
            $('.alertMessage').text("Seguro que quieres eliminar la foto de tu trabajo?");
        }
        else{
            $('.alertMessage').text("Seguro que quieres eliminar la foto del certificado?");
        }
            
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                   
                    if($(e.currentTarget).attr('data-delete')=="photos"){
                        /*var thisSlide = swiperDyn.slides[swiperDyn.activeSlide];
                        thisSlide = $(thisSlide).find('img').attr('src');*/
                        timeFotos--;
                        var urlsplit = window.fotoProfesionalAPIURL[swiperDyn.activeSlide].split("/");
                        deleteFotos.push(urlsplit[4]);
                        var index = window.fotoProfesionalAPIURL.indexOf(swiperDyn.activeSlide);
                        window.fotoProfesionalAPIURL.splice(index, 1);
                        swiperDyn.prependSlide(swiperDyn.slides[swiperDyn.activeSlide]);
                        swiperDyn.swipeTo(0);
                        swiperDyn.removeSlide(0);
                        if(swiperDyn.slides.length==1){
                            $('.pagination-sd').empty();
                        }
                        if(swiperDyn.slides.length==0){
                            $('#galeria').css({'display':'none'});
                        }
                        /*var srcCompare;
                        for(var i=0; i<modelProfesional.get("imatges").length; i++){
                            srcCompare = window.IPServidor + modelProfesional.get("imatges")[i].imatges;
                            if(srcCompare==thisSlide){
                                
                            }
                        }*/
                    }else{
                        /*var thisSlide = swiperDynAcred.slides[swiperDynAcred.activeSlide];
                        thisSlide = $(thisSlide).find('img').attr('src');*/
                        timeAcreditacio--;
                        var urlsplit = window.fotoCertificatAPIURL[swiperDynAcred.activeSlide].split("/");
                        deleteCertificats.push(urlsplit[4]);
                        var index = window.fotoCertificatAPIURL.indexOf(swiperDynAcred.activeSlide);
                        window.fotoCertificatAPIURL.splice(index, 1);
                        swiperDynAcred.prependSlide(swiperDynAcred.slides[swiperDynAcred.activeSlide]);
                        swiperDynAcred.swipeTo(0);
                        swiperDynAcred.removeSlide(0);
                        if(swiperDynAcred.slides.length==1){
                            $('.pagination-sdAcred').empty();
                        }
                        if(swiperDynAcred.slides.length==0){
                            $('#galeriaAcred').css({'display':'none'});
                        }
                        /*var srcCompare;
                        for(var i=0; i<modelProfesional.get("acreditacions").length; i++){
                            srcCompare = window.IPServidor + modelProfesional.get("acreditacions")[i].acreditacionsProfesionals;
                            if(srcCompare==thisSlide){
                                timeAcreditacio--;
                                deleteCertificats.push(modelProfesional.get("acreditacions")[i].id);
                            }
                        }*/
                    }
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });
        
       
    },

    fixaCategoria: function ( e ){

        if(dropdown){
            if($(e.currentTarget).attr('data-categoria')=="reparacions"){
                customAlert('ELECTRICISTAS, FONTANEROS, ALBAÑILES, CARPINTEROS, CERRAJERIA, ELECTRODOMESTICOS, TÉC. ELECTRODOMESTICOS, TV, EBANISTERIA, PINTORES, EMPAPELADORES... Y TODAS LAS ACTIVIDADES RELACIONADAS', 2, 0, '', 0, false, 'Reparaciones/reformas', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="asesorament"){
                customAlert('CONTABILIDAD, FISCAL, LABORAL, LEGAL, ABOGADOS, INGENIEROS, ARQUITECTOS, SEGUROS, COMERCIAL, MARQUETING... Y TODAS LAS ACTIVIDADES DE ASESORAMIENTO Y/O GESTION', 2, 0, '', 0, false, 'asesoramiento/gestión', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="informatica"){
                customAlert('PROGRAMACION, DESARROLLO, MANTENIMIENTO, INSTALACION, SOPORTE, REDES... Y TODAS LAS ACTIVIDADES PROPIAS DE LA INFORMATICA', 2, 0, '', 0, false, 'informática', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="formacio"){
                customAlert('IDIOMAS, MUSICA, COMERCIAL, REFUERZOS DE ASIGNATURAS, VOCAL... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL CONOCIMIENTO', 2, 0, '', 0, false, 'formación', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="arts"){
                customAlert('GRAFICO, PUBLICIDAD, ARQUITECTURA, WEB, INDUSTRIAL, TEATRAL, VIDEO, ACTORES... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL ARTE Y/O DISEÑO', 2, 0, '', 0, false, 'artes/diseño', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="automocio"){
                customAlert('MECANICA, COMPRA/VENTA... Y TODAS LAS ACTIVIDADES RELACIONADAS CON MOTOS, CAMIONES Y COCHES', 2, 0, '', 0, false, 'automoción', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="serveis"){
                customAlert('CUIDADO ANCIANOS, LIMPIEZA, CANGUROS, AUPAIRS, JARDINERIA, CUIDADO INFANTIL, MASAJISTAS, FISIOTERAPEUTAS, MONTADORES MOBILIARIO... Y TODAS LAS ACTIVIDADES RELACIONADAS CON LOS SERVICIOS HOGAR', 2, 0, '', 0, false, 'servicios hogar', true, e);
            }
        }else{
            dropdown=true;
            $('#dropdown').animate({height:$('#DropContent').outerHeight()});
            $("#dropButton").attr("src","img/arrow_down.png");
            $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
            $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
        }
    },

    mostraCategoria: function( e ){
        if(dropdown){
            categoria="undefined";
            dropdown=false;
            $('#dropdown').animate({height:0});
            $("#dropButton").attr("src","img/button_login_cliente.png");
        }else{
            dropdown=true;
            $('#dropdown').animate({height:$('#DropContent').outerHeight()});
            $("#dropButton").attr("src","img/arrow_down.png");
            $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
            $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
        }
    },

    addMarkerForAddress: function( e ){
        outAddMarker();
    },

    canviarBotonsAfegirCertificat: function ( e ) {
        $('#boto_afegir_foto_certificat_pressed').css({'display':'block'});
        $('#boto_afegir_foto_certificat').css({'display':'none'});
        $('#boto_afegir_logo_pressed').css({'display':'none'});
        $('#boto_afegir_logo').css({'display':'block'});
        $('#boto_afegir_fotos_pressed').css({'display':'none'});
        $('#boto_afegir_fotos').css({'display':'block'});
        llocFoto = "certificat";
    },

    canviarBotonsAfegirFotos: function ( e ) {
        $('#boto_afegir_fotos_pressed').css({'display':'block'});
        $('#boto_afegir_fotos').css({'display':'none'});
        $('#boto_afegir_foto_certificat_pressed').css({'display':'none'});
        $('#boto_afegir_foto_certificat').css({'display':'block'});
        $('#boto_afegir_logo_pressed').css({'display':'none'});
        $('#boto_afegir_logo').css({'display':'block'});
        llocFoto = "fotos";
    },

    canviarBotonsAfegirLogo: function ( e ) {
        $('#boto_afegir_logo_pressed').css({'display':'block'});
        $('#boto_afegir_logo').css({'display':'none'});
        $('#boto_afegir_foto_certificat_pressed').css({'display':'none'});
        $('#boto_afegir_foto_certificat').css({'display':'block'});
        $('#boto_afegir_fotos_pressed').css({'display':'none'});
        $('#boto_afegir_fotos').css({'display':'block'});
        llocFoto = "logo";
    },

    getFoto: function( e ) {
        e.preventDefault();

        if((llocFoto=="fotos" && timeFotos<4) || (llocFoto=="certificat" && timeAcreditacio<4) || (llocFoto=="logo")){

            //amb aquesta variable definim si volem agafar la foto de la galeria o el móbil
            if($(e.currentTarget).attr('data-foto')=="camera"){
                var definedSourceType = navigator.camera.PictureSourceType.CAMERA;
            }else{
                var definedSourceType = navigator.camera.PictureSourceType.PHOTOLIBRARY;
            }

            navigator.camera.getPicture(
                function onPhotoURISuccess(imageURI) {

                    loadingSpinner("on");
                    var tries = 0;
                    var ft = new FileTransfer();
                    
                    var options = new FileUploadOptions();
                    var fileName = "" + (new Date()).getTime() + ".jpg"; // consider a more reliable way to generate unique ids
                    options.fileKey="file";
                    options.fileName=fileName;
                    options.mimeType="image/jpeg";
                    options.chunkedMode=false;
                    
                   /* s3Uploader.upload(imageURI, fileName)
                        .done(function () {
                            alert("S3 upload succeeded");
                        })
                        .fail(function () {0
                            alert("S3 upload failed");
                     });*/
                  
                    
                    var signingURI = window.IPServidor+ "/signing";
                    
                    $.ajax({url: signingURI, dataType: "json", type: "GET"})
                    .done(function (data) {
    	        	
    	        	    options.params = {
    	                    "key":  options.fileName,
    	                    "AWSAccessKeyId": data.awsKey,
    	                    "acl": "public-read",
    	                    "policy": data.policy,
    	                    "signature": data.signature,
    	                    "Content-Type": "image/jpeg"
    	                };
    	                
                   	    ft.upload(imageURI, s3URI, win, fail, options, false);
                    })
                    .fail(function (error) {
                    	customAlert("Ha fallado la connexión con el servidor. Intentalo de nuevo.",0,2000,"",3,false);
                        loadingSpinner("off");
                    });
                    
                    //ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, true);
                                                                       
                    function win(r) {
                        //alert('entrem a function win');
                        //alert(llocFoto);
                        loadingSpinner("off");
                      
                        if(llocFoto=="logo"){
                            $("#fotoLogo").attr("src",imageURI);
                            $('#contenidorFotoLogo').css({'display':'block'});

                            window.fotoLogoAPIURL = options.fileName;
                        }else if(llocFoto=="fotos"){
                            //alert('entrem a fotos');
                            if(timeFotos==1){
                                //alert('borrem fotos');
                                $('#galeria').css({'display':'block'});
                                window.fotoProfesionalAPIURL = [];
                            }
                            var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+imageURI+'"/>');
                            newSlide.append();

                            var fotoProfesionalValues = ({
                                imatges: options.fileName
                            });

                            var modelProfesionalFoto = new window.FotoProfesional(fotoProfesionalValues);
                            modelProfesionalFoto.url = window.IPServidor + '/api/buonjobs/fotoProfesional/';
                            modelProfesionalFoto.save( {} , {
                                beforeSend: sendAuthentication,
                                error: function(model, response) {
                                     loadingSpinner("off");
                                },
                                success: function(model, response) {
                                    timeFotos++;
                                    window.fotoProfesionalAPIURL.push(response['resource_uri']);
                                    
                                }
                            });
                        }else if(llocFoto=="certificat"){
                            if(timeAcreditacio==1){
                                $('#galeriaAcred').css({'display':'block'});
                                window.fotoCertificatAPIURL = [];
                            }
                            //alert('entrem a certificat');
                            var newSlide = swiperDynAcred.createSlide('<img id="ampliar" src="'+imageURI+'"/>');
                            newSlide.append();
                           
                            var certificatProfesionalValues = ({
                                acreditacionsProfesionals: options.fileName
                            });

                            var modelProfesionalCertificat = new window.AcreditacioProfesional(certificatProfesionalValues);
                            modelProfesionalCertificat.url = window.IPServidor + '/api/buonjobs/acreditacioProfesional/';
                            modelProfesionalCertificat.save( {} , {
                                beforeSend: sendAuthentication,
                                error: function(model, response) {
                                    //alert(response.responseText);
                                    loadingSpinner("off");
                                },
                                success: function(model, response) {
                                   
                                    timeAcreditacio++;
                                    window.fotoCertificatAPIURL.push(response['resource_uri']);
                                }
                            });
                        }
                    }
                    function fail(error) {
                        //alert('fail');
                        if(tries<3){
                            tries++;
                            //alert(tries);
                            options.chunkedMode=false;
                            ft.upload(imageURI, s3URI, win, fail, options, true);
                            //ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, true);
                        }else{
                            loadingSpinner("off");
                            customAlert("Ha fallado la subida de la imagen",0,2000,"",3,false);
                        }
                    }
                },
                function onFail(message) {
                    if(message!="Selection cancelled." && message!="Camera cancelled."){
                        //alert('Ocurrió un error: ' + message);
                    }
                },
               
                { quality: 40, sourceType: definedSourceType, encodingType: Camera.EncodingType.JPEG, targetWidth: 560,targetHeight: 560, correctOrientation: true}
            );
        }
    },

    peticioRegistreProfesionalServer: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
    
        if($("#formulariLoginProfesional").valid()){
            if(categoria=="undefined"){
                $('html, body').animate({
                    scrollTop: $('.parent').offset().top
                }, 1000);
                $('#errorVerificarCategoria').css({'display':'block'});
                loadingSpinner("off");
            }else{
                if(!booleaGeneral){
                    $('html, body').animate({
                        scrollTop: $('.titleRegistre').offset().top
                    }, 1000);
                    $('#errorVerificarMapa').css({'display':'block'});
                    loadingSpinner("off");
                }else{
                    comprovaDades();
                }
            }
        }else{
            loadingSpinner("off");
        }

        function comprovaDades(){
           
           
        	if(deleteFotos.length>0){
                var successFotos = 0;
                for(var i=0;i<deleteFotos.length;i++){

                	var fotoProfessionalValues = ({
                         id: deleteFotos[i]
                     });
                	var modelProfesionalFoto = new window.FotoProfesional(fotoProfessionalValues);
                  
                    modelProfesionalFoto.url = window.IPServidor + '/api/buonjobs/fotoProfesional/'+deleteFotos[i]+'/';
                   
                    modelProfesionalFoto.destroy({
                        beforeSend: sendAuthentication,
                        success: function(){
                            
                        	successFotos++;
                            if(successFotos==deleteFotos.length){
                                if(deleteCertificats.length>0){
                                    successFotos=0;
                                    for(var i=0;i<deleteCertificats.length;i++){

                                	    var certificatValues = ({
                                          id: deleteCertificats[i]
                                        });
                                    	var modelProfesionalCertificat = new window.AcreditacioProfesional(certificatValues);
                                        modelProfesionalCertificat.url = window.IPServidor + '/api/buonjobs/acreditacioProfesional/'+deleteCertificats[i]+'/';
                                      
                                        modelProfesionalCertificat.destroy({
                                            beforeSend: sendAuthentication,
                                            success: function(){
                                                successFotos++;
                                                if(successFotos==deleteCertificats.length){
                                                    keepGoing();
                                                }
                                            }
                                        });
                                    }
                                }else{
                                    keepGoing();
                                }
                            }
                        }
                    });
                }
            }else if(deleteCertificats.length>0){
                var successFotos=0;
                for(var i=0;i<deleteCertificats.length;i++){
            	    var certificatValues = ({
                       id: deleteCertificats[i]
                    });
                    var modelProfesionalCertificat = new window.AcreditacioProfesional(certificatValues);
                    modelProfesionalCertificat.url = window.IPServidor + '/api/buonjobs/acreditacioProfesional/'+deleteCertificats[i]+'/';
                 
                    
                    modelProfesionalCertificat.destroy({
                        beforeSend: sendAuthentication,
                        success: function(){
                            successFotos++;
                            if(successFotos==deleteCertificats.length){
                                keepGoing();
                            }
                        }
                    });
                }
            }else{
                keepGoing();
            }

            function keepGoing(){

                var profesionalModel = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
                var direccioValues = ({
                    id: profesionalModel.get("direccio").id,
                    numero: $("#numero").val(),
                    carrer: $("#carrer").val(),
                    ciutat: $("#ciutat").val(),
                    pais: $("#pais").val(),
                    codipostal: $("#codiPostal").val(),
                    latitud: returnedValue.lat(),
                    longitud: returnedValue.lng()
                });

                var formUserValues = ({
                    id: profesionalModel.get("user").id,
                    usuari:  $("#usuari").val(),
                    clau:  $("#clau").val(),
                    correu:  $("#correu").val()
                });

                var modelDireccio = new window.Direccio (direccioValues);
                modelDireccio.url = window.IPServidor + profesionalModel.get("direccio").resource_uri;
                // Backbone.Model.save returns a jqXHR object
                modelDireccio.save( {} , {
                    beforeSend: sendAuthentication,
                    error: function(model, response) {
                        customAlert(response.responseText,1,0,"",3,false);
                        loadingSpinner("off");
                    },
                    success: function(model, response) {
                        var direccioAPIURL = response.resource_uri;

                        var modelUser = new window.User(formUserValues);
                        modelUser.url = window.IPServidor + profesionalModel.get("user").resource_uri;
                        //alert(modelUser.url);

                        modelUser.save( {} , {
                            beforeSend: sendAuthentication,
                            error: function(model, response) {
                            	customAlert(response.responseText,1,0,"",3,false);
                                loadingSpinner("off");
                            },
                            success: function(model, response) {
                                var userURIAPI = response.resource_uri;

                                //he de guardar nou usuari per Basic Authentication
                                var authUserValues = ({
                                    username:  $("#usuari").val(),
                                    clau:  $("#clau").val()
                                });
                                window.localStorage.setItem("auth", JSON.stringify(authUserValues));

                                var formProfesionalValues = ({
                                    id: profesionalModel.get("id"),
                                    user: userURIAPI,
                                    nom: $("#nom").val(),
                                    telefon: $("#telefon").val(),
                                    empresa:  $("#empresa").val(),
                                    activitat: categoria,
                                    descripcio: $("#descripcio").val(),
                                    logotip: window.fotoLogoAPIURL,
                                    direccio: direccioAPIURL,
                                    acreditacions: window.fotoCertificatAPIURL,
                                    imatges: window.fotoProfesionalAPIURL,
                                    cif: $("#CIF").val(),
                                    distanciaTreballs: $("#distancia").val()
                                });

                               // alert(JSON.stringify(formProfesionalValues));

                                var modelProfesional = new window.Profesional (formProfesionalValues);
                                modelProfesional.url = window.IPServidor + profesionalModel.get("resource_uri");

                                modelProfesional.save( {} , {
                                    beforeSend: sendAuthentication,
                                    error: function(model, response) {
                                    	customAlert(response.responseText,1,0,"",3,false);
                                        loadingSpinner("off");
                                    },
                                    success: function(model, response) {
                                        var modelProfesional = new window.Profesional();
                                        modelProfesional.url = window.IPServidor + profesionalModel.get("resource_uri");
                                        modelProfesional.fetch({
                                            beforeSend: sendAuthentication,
                                            error: function(model, response) {
                                                customAlert(response.responseText,1,0,"",3,false);
                                                loadingSpinner("off");
                                            },
                                            success: function (model, response) {
                                                var formUserValues = ({
                                                    id: model.get("user").id,
                                                    username:  $("#usuari").val(),
                                                    clau:  $("#clau").val(),
                                                    email:  model.get("user").email,
                                                    resource_uri: model.get("user").resource_uri
                                                });
                                                model.set({user: formUserValues});
                                                window.localStorage.setItem("user", JSON.stringify(model));
                                                //alert('abans custom alert modifica');
                                                customAlert("Cuenta profesional modificada!",0,2000,"",1,false);
                                                loadingSpinner("off");
                                                //alert('despres custom alert modifica');
                                                 
                                                // window.history.back();
                                                if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                                    gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarUsuari - Gestio Professional", "Click", "Gestio Professional", 1);
                                                }
                                            }
                                        });
                                    }
                                });
                            }
                        });
                    }
                });
            }
        }
    },

    eliminarProfesional: function ( e ) {
        e.preventDefault();

        $('.customAlert').css('width', $(window).width() + 'px', 'important');

        $('.alertMessage').text("Seguro que quieres eliminar la cuenta?");
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    loadingSpinner("on");
                    closePage();
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });

        function closePage(){

            var modelProfesional = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
            var profesionalValues = ({
                id: modelProfesional.get("id")
            });

            var profesionalModel = new window.Profesional(profesionalValues);
            profesionalModel.url = window.IPServidor + modelProfesional.get("resource_uri");
            profesionalModel.destroy({
                beforeSend: sendAuthentication,
                error: function() {
                    customAlert("Error al dar de baja el usuario! Contacte con el administrador de buonjobs",0,1500,"",2,false);
                    loadingSpinner("off");
                },
                success: function() {
                    customAlert("Se ha dado de baja la cuenta de profesional!",0,2000,"",5,true);
                    if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                        gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button EliminarUsuari - Gestio Professional", "Click", "Gestio Professional", 1);
                    }
                }
            });
        }
    },


    comments1: function( e ) {
        customAlert("si tienes documentos de alta en autónomos y seguro de responsabilidad de civil o si cuentas con otros documentos que acrediten que eres un buen profesional, la pertenencia a un Gremio Oficial o colegio, puedes conseguir un mejor resultado en Bu:on Jobs",1,0,"",3,false);
    },

    comments2: function( e ) {
        customAlert("puedes subir fotos de tus anteriores trabajos para causar mejor impresión cuando presentes tu candidatura para un trabajo",1,0,"",3,false);
    },

    comments3: function( e ) {
        customAlert("puedes describir el trabajo que haces o como lo haces, cuanto más completo mejor!",1,0,"",3,false);
    },

    comments4: function( e ) {
        customAlert("especifica el radio de quilómetros hasta el que quieres recibir ofertas de los clientes",1,0,"",3,false);
    }
});

function outAddMarker(){
    //console.log("hola");
    if($("#formulariPosicio").valid()){

        var address = $("#carrer").val() +', '+ $("#numero").val() +', '+ $("#ciutat").val() +', '+ $("#codiPostal").val();

        var latLangForLocation = getLatLangFromAddress(address);
        ////console.log("Value returned by getLatLangFromAddress " +latLangForLocation);
    }
    function getLatLangFromAddress(address){
        var geocoder = new google.maps.Geocoder();
        geocoder.geocode( { 'address': address}, function(results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                returnedValue =results[0].geometry.location;

                $('#map').css({'display':'block'});
                $('.refreshMap').css({'display':'block'});
                
                $('#boto_mapa').css({'display':'none'});
                $('#errorVerificarMapa').css({'display':'none'});

                //carreguem mapa
                try{
                    var currentLocationLatAndLong = new google.maps.LatLng(returnedValue.lat(),returnedValue.lng());
                    
                    var mapOptions ={
                        zoom:10,
                        center:currentLocationLatAndLong,
                        mapTypeId: google.maps.MapTypeId.ROADMAP
                    };
                    var mapDiv = document.getElementById("map");
                    map = new google.maps.Map(mapDiv,mapOptions);

                    addMarker(returnedValue);
                    booleaGeneral=true;
                }catch(e){
                    //alert("Error occured in ConsultantLocator.displayMap() " + e);
                }
            }else{
                //alert("Geocode was not successful for the following reason: " + status);
            }
        });
    }

    function addMarker(latLng){
        var markerOptions = new google.maps.Marker({
            map: map,
            position: latLng,
            clickable:true
        });
        var marker = new google.maps.Marker(markerOptions);
        var infoWindowOptions = {
            content: address,
            position: latLng
        };
        var infoWindow = new google.maps.InfoWindow(infoWindowOptions);
        google.maps.event.addListener(marker, "click", function(){
            infoWindow.open(map);
            //console.log("open map");
        });
    }
}