window.HistorialClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render:function (eventName) {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #proposta':'vesSeguentPantalla',
        'click #botoLlistar':'mostraPropostes'
    },

    renderSlider: function ( e ) {

        collectionProposta = new window.CollectionProposta();
        var content = $('ul');

        $.ajax({
            url: window.IPServidor + '/api/buonjobs/proposta/',
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {
                //var missatgeEnJson = JSON.stringify(missatgeResposta);

                //alert(missatgeEnJson);
                var quantesPropostes = missatgeResposta.objects.length;
                var logoProfesional = "";
                
                for(var i=0;i<quantesPropostes;i++) {

                    if(missatgeResposta.objects[i].oferta.imatges.length>0){
                        logoProfesional = missatgeResposta.objects[i].oferta.imatges[0].imatgeOferta;
                    }else{
                        logoProfesional = "img/default_image.png";
                    }
                    
                    var valuesPropostaLlistatModel = ({
                        id: missatgeResposta.objects[i].id,
                        nomprofesional: missatgeResposta.objects[i].profesional.user.username,
                        empresa: missatgeResposta.objects[i].profesional.empresa,
                        logo: logoProfesional,
                        resumoferta: missatgeResposta.objects[i].oferta.resum,
                        estatAcceptacio: missatgeResposta.objects[i].estatAcceptacio
                    });
          
                    var modelAux = new window.PropostaModelLlistat(valuesPropostaLlistatModel);
                    if(modelAux.get("estatAcceptacio")==2){
                        content.append(new PropostesClientItemView({model: modelAux}).render().el);
                    }
                    collectionProposta.add(modelAux);
                }
                $('.btnHover').on('touchstart', function(e){
                    $(this).addClass('tapped');
                });
                $('.btnHover').on('touchend', function(e){
                    setTimeout(function(){
                        $('.btnHover').removeClass('tapped');
                    }, 200);
                });

                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat propostes fail");
                loadingSpinner("off");
            }
        });
    },

    vesSeguentPantalla: function ( e ) {
        loadingSpinner("on");
        var proposta = $(e.currentTarget).attr('data-proposta');
        var urlLoginClientRecurs = window.IPServidor + '/api/buonjobs/proposta/'+proposta+'/';

        var modelProposta = new window.Proposta();
        modelProposta.url = urlLoginClientRecurs;
        modelProposta.fetch({
            beforeSend: sendAuthentication,
            error: function () {
                //alert("error al cargar la propuesta");
                loadingSpinner("off");
            },
            success: function (model, response) {
                delete window.collectionProposta;
                window.localStorage.setItem("propose", JSON.stringify(model));
                if(model.get("estatAcceptacio")==4){
                    app.navigate("propostaValoradaClient", true);
                }else if(model.get("estatAcceptacio")==2){
                    app.navigate("valorarProposta", true);
                }
            }
        });
    },

    mostraPropostes: function ( e ) {
        var propostes = collectionProposta.models;
        var quantesPropostes = propostes.length;

        $('ul').empty();
        var content = $('ul',$(this.el));

        if($(e.currentTarget).attr('data-llista')=="candidatas"){
            $("[data-llista='candidatas']").addClass('listSelected');
            $("[data-llista='totes']").removeClass('listSelected');
            for (var i = 0; i < quantesPropostes; i++) {
                if(propostes[i].get("estatAcceptacio")==4){
                    content.append(new PropostesClientItemView({model: propostes[i]}).render().el);
                }
            }
        }else{
            $("[data-llista='candidatas']").removeClass('listSelected');
            $("[data-llista='totes']").addClass('listSelected');
            for (var i = 0; i < quantesPropostes; i++) {
                if(propostes[i].get("estatAcceptacio")==2){
                    content.append(new PropostesClientItemView({model: propostes[i]}).render().el);
                }
            }
        }
    },

    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        delete window.collectionProposta;
        loadingSpinner("on");
        window.history.back();
    }
});

window.PropostesClientItemView = Backbone.View.extend({

    tagName:"li",

    initialize: function () {},

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        return this;
    }
});

