window.LoginClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #loginClient':'comprovaLoginClient',
        'click #registerClientButton':'vesARegistreClient',
        'click #back_boto':'vesAPantallaAnterior',
        'click #forgotPass':'vesPantallaForgot',
        'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {
        
        $('#formulariLoginClient').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            if($("#formulariLoginClient").valid()){
                loadingSpinner("on");

                var url = window.IPServidor + '/api/buonjobs/user/client/login/';
                //console.log('Loggin in... ');

                var formData = {};
                
                $('#formulariLoginClient div').children( 'input' ).each( function( i, el ) {
                    if( $( el ).val() != '' ){
                        formData[ el.id ] = $( el ).val();
                    }
                });

                $.ajax({
                    url:url,
                    type:'POST',
                    dataType:"json",
                    contentType:"application/json",
                    data: JSON.stringify(formData),
                    success:function (data) {
                        ////console.log(["Login request details: ", data]);
                        var formUserValues = ({
                            username:  $("#usuari").val(),
                            clau:  $("#clau").val()
                        });
                        window.localStorage.setItem("auth", JSON.stringify(formUserValues));
                        window.localStorage.setItem("logged","true");

                        if(data.success) {  // If there is an error, show the error messages
                            var urlLoginClientRecurs = window.IPServidor + '/api/buonjobs/client/'+data.user_id+'/';

                            var modelClient = new window.Client();
                            modelClient.url = urlLoginClientRecurs;
                            //console.log(modelClient.url);
                            modelClient.fetch({
                                beforeSend: sendAuthentication,
                                error: function (model, response) {
                                    customAlert(response.responseText,0,2000,"",3,false);
                                    loadingSpinner("off");
                                },
                                success: function (model, response) {
                                    try{
                                        var formUserValues = ({
                                            id: model.get("user").id,
                                            username:  $("#usuari").val(),
                                            clau:  $("#clau").val(),
                                            email:  model.get("user").email,
                                            resource_uri: model.get("user").resource_uri
                                        });
                                        model.set({user: formUserValues});
                                        window.localStorage.setItem("user", JSON.stringify(model));
                                        app.navigate('menuClient', true);
                                        if(typeof device != "undefined"){
                                            pushNotification = window.plugins.pushNotification;
                                            if (device.platform == 'android' || device.platform == 'Android') {
                                                //registering android
                                                pushNotification.register(successHandler, errorHandler, {"senderID":"387162003553","ecb":"onNotificationGCM"});    // required!
                                            } else {
                                                //registering iOS
                                                pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});   // required!
                                            }
                                            if(window.localStorage.getItem("gaplugin")=="true"){
                                                gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Login - Login Client", "Click", "Login Client", 1);
                                            }
                                        }
                                     
                                    }catch(err){
                                        
                                    }
                                }
                            });
                        }else{
                            customAlert(data.message,0,1500,"",3,false);
                            loadingSpinner("off");
                        }
                    },
                    error: function (errormessage) {
                        customAlert(JSON.parse(errormessage.responseText)["message"],0,2000,"",3,false);
                        loadingSpinner("off");
                    }
                });
            }
        });
        
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });

        $('#forgotPass').on('touchstart', function(e){
            $(this).addClass('fontTapped');
        });
        $('#forgotPass').on('touchend', function(e){
            setTimeout(function(){
                $('#forgotPass').removeClass('fontTapped');
            }, 200);
        });

        //Definim les normes a validar
        $("#formulariLoginClient").validate({
            rules: {
                usuari: {
                    required: true,
                    minlength: 2
                },
                clau: {
                    required: true,
                    minlength: 5
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
                
            }
        });

        var height = 100;
        /*if(bannerOn){
            height = 148;
            $('.fixedBottom').css({'margin-bottom':'50px'});
            $('.banner').css({'top':deviceHeight-50+'px'});
            _inmobi.getNewAd(document.getElementById('my-ad-slot'));
        }*/
        $('.fixedBottom').css({'top':deviceHeight-height+'px'});
        window.scrollTo(0,0);
        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        //console.log("he clicat al boto de back");
    	document.activeElement.blur();
        $("input").blur();
         
        loadingSpinner("on");
        //window.history.back();
        app.navigate('', true);
    },

    vesPantallaForgot: function ( e ) {
        e.preventDefault();
        document.activeElement.blur();
        $("input").blur();
      
        loadingSpinner("on");
        app.navigate('forgotPass', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ForgotPassword - Login Client", "Click", "Login Client", 1);
        }
    },

    vesARegistreClient: function( e ) {
        e.preventDefault();
        document.activeElement.blur();
        $("input").blur();
        loadingSpinner("on");
        app.navigate('registreClient', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Registre - Login Client", "Click", "Login Client", 1);
        }
    },

        
    comprovaLoginClient: function( event ) {
        event.preventDefault(); // Don't let this button submit the form
        
        document.activeElement.blur();
        $("input").blur();
        window.scrollTo(0,0);
         
        if($("#formulariLoginClient").valid()){
            loadingSpinner("on");

            var url = window.IPServidor + '/api/buonjobs/user/client/login/';
            //console.log('Loggin in... ');

            var formData = {};
            
            $('#formulariLoginClient div').children( 'input' ).each( function( i, el ) {
                if( $( el ).val() != '' ){
                    formData[ el.id ] = $( el ).val();
                }
            });

            $.ajax({
                url:url,
                type:'POST',
                dataType:"json",
                contentType:"application/json",
                data: JSON.stringify(formData),
                success:function (data) {
                    ////console.log(["Login request details: ", data]);
                    var formUserValues = ({
                        username:  $("#usuari").val(),
                        clau:  $("#clau").val()
                    });
                    window.localStorage.setItem("auth", JSON.stringify(formUserValues));
                	window.localStorage.setItem("logged","true");

                    if(data.success) {  // If there is an error, show the error messages
                        var urlLoginClientRecurs = window.IPServidor + '/api/buonjobs/client/'+data.user_id+'/';

                        var modelClient = new window.Client();
                        modelClient.url = urlLoginClientRecurs;
                        //console.log(modelClient.url);
                        modelClient.fetch({
                            beforeSend: sendAuthentication,
                            error: function (model, response) {
                                customAlert(response.responseText,0,3000,"",3,false);
                                loadingSpinner("off");
                            },
                            success: function (model, response) {
                                try{
                                    var formUserValues = ({
                                        id: model.get("user").id,
                                        username:  $("#usuari").val(),
                                        clau:  $("#clau").val(),
                                        email:  model.get("user").email,
                                        resource_uri: model.get("user").resource_uri
                                    });
                                    model.set({user: formUserValues});
                                    window.localStorage.setItem("user", JSON.stringify(model));
                                    app.navigate('menuClient', true);
                                    if(typeof device != "undefined"){
                                        pushNotification = window.plugins.pushNotification;
                                        if (device.platform == 'android' || device.platform == 'Android') {
                                            //registering android
                                            pushNotification.register(successHandler, errorHandler, {"senderID":"387162003553","ecb":"onNotificationGCM"});    // required!
                                        } else {
                                            //registering iOS
                                            pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});   // required!
                                        }
                                        if(window.localStorage.getItem("gaplugin")=="true"){
                                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Login - Login Client", "Click", "Login Client", 1);
                                        }
                                    }
                                }catch(err){
                                    
                                }
                            }
                        });
                    }else{
                        customAlert(data.message,0,3000,"",3,false);
                        loadingSpinner("off");
                    }
                },
                error: function (errormessage) {
                    customAlert(JSON.parse(errormessage.responseText)["message"],0,3000,"",3,false);
                    loadingSpinner("off");
                }
            });
        }
    }
});