window.MenuPrincipalClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #btn_alta_oferta':'vesACrearOferta',
        'click #back_boto':'vesAPantallaAnterior',
        'click #btn_gestio_proposta':'vesGestioPropostes',
        'click #btn_modificar_ofertes':'vesModificarOfertes',
        'click #btn_historial':'vesHistorial',
        'click #btn_settings':'mostraSettings',
        'click #gestioConta':'vesGestioConta',
        'click #compartir':'compartir',
        'click #logout':'surt'
    },

    renderSlider: function ( e ) {

        if(typeof device != "undefined"){
            if (device.platform == 'android' || device.platform == 'Android') {} else {
                $('#back_boto').css('display', 'none');
            }
        }

        $('#verticalMid').css('margin-top', (-$('#verticalMid').outerHeight()/2)+30 + 'px', 'important');

        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        dropdown=false;
        
        $.ajax({
            url: window.IPServidor + '/api/buonjobs/notificacio/',
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {
                console.log(missatgeResposta);
                var quantesNotificacions = missatgeResposta.objects.length;

                if(quantesNotificacions>0){
                    //alert("primera notificacio!");
                    var notificacions = {
                        "data": []
                    };
                    var number;
                    
                    for(var i=0;i<quantesNotificacions;i++) {                  
                        var valuesNotifications = ({
                            id: missatgeResposta.objects[i].id,
                            idNotificacio: missatgeResposta.objects[i].idTipus,
                            messageType: missatgeResposta.objects[i].tipus
                        });
                        notificacions.data.push(valuesNotifications);

                        if(missatgeResposta.objects[i].tipus==0){
                            $('#nP').css('display','block');
                            number = parseInt($('#nP p').text())+1;
                            $('#nP p').text(number);
                        }
                    }
                    window.localStorage.setItem("notifications", JSON.stringify(notificacions));
                }
                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat ofertes fail");
                loadingSpinner("off");
            }
        });
    },

    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        gaPlugin.exit(nativePluginResultHandler, nativePluginErrorHandler);
        //alert('exit app');
        navigator.app.exitApp();
    },

    compartir: function ( e ) {
        e.preventDefault();
        //auth.FBLoginStatus();
        window.plugins.socialsharing.available(function(isAvailable) {
            if (isAvailable) {
                // use a local image from inside the www folder:
                window.plugins.socialsharing.share('', 'BuonJobs', 'http://buonjobs.com/buon_logo_client.png', 'http://buonjobs.com/'); // succes/error callback params may be added as 4th and 5th param
            }
        });
    },

    surt: function ( e ) {
        customAlert("Seguro que quieres cerrar sesión?",2,0,"",3,true);
    },

    mostraSettings: function( e ){
        if(dropdown){
            dropdown=false;
            $('#settings').animate({height: 0}, function(){
                $('#settings').css({'display':'none'})
            });
        }else{
            dropdown=true;
            $('#settings').css({'display':'block'})
            $('#settings').animate({height: $('#DropContent').outerHeight()});
        }
    },

    vesACrearOferta: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        app.navigate('crearOferta', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button CrearOferta - Menu Client", "Click", "Menu Client", 1);
        }
    },

    vesGestioPropostes: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestionPropuestasClient', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button GestioPropostes - Menu Client", "Click", "Menu Client", 1);
        }
    },

    vesModificarOfertes: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('modificarOferta', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarOferta - Menu Client", "Click", "Menu Client", 1);
        }
    },

    vesHistorial: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('historial', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Historial - Menu Client", "Click", "Menu Client", 1);
        }
    },

    vesGestioConta: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestioContaClient', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button GestioConta - Menu Client", "Click", "Menu Client", 1);
        }
    }
});
