window.OfertaLlistatModificarView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render:function (eventName) {

        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #oferta':'vesSeguentPantalla'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {
        
        var content = $('ul');

        $.ajax({
            url: window.IPServidor + '/api/buonjobs/oferta/',
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {
                console.log(missatgeResposta);
                var quantesOfertes = missatgeResposta.objects.length;
                var fotoOferta = "";
                
                for(var i=0;i<quantesOfertes;i++) {

                    if(missatgeResposta.objects[i].imatges.length>0){
                        fotoOferta = missatgeResposta.objects[i].imatges[0].imatgeOferta;
                    }else{
                        fotoOferta = "img/default_image.png";
                    }                    
                    var valuesOfertaLlistatModel = ({
                        id: missatgeResposta.objects[i].id,
                        resum: missatgeResposta.objects[i].resum,
                        caduca: missatgeResposta.objects[i].caducitatOferta,
                        ciutat: missatgeResposta.objects[i].direccio['ciutat'],
                        foto: fotoOferta
                    });

                    var modelAux = new window.OfertaModelLlistat(valuesOfertaLlistatModel);
                    content.append(new OfertaLlistatItemView({model: modelAux}).render().el);
                }

                $('.btnHover').on('touchstart', function(e){
                    $(this).addClass('tapped');
                });
                $('.btnHover').on('touchend', function(e){
                    setTimeout(function(){
                        $('.btnHover').removeClass('tapped');
                    }, 200);
                });
                
                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat ofertes fail");
                loadingSpinner("off");
            }
        });
    },

    vesSeguentPantalla: function ( e ) {
        loadingSpinner("on");
        var oferta = $(e.currentTarget).attr('data-oferta');
        var urlLoginClientRecurs = window.IPServidor + '/api/buonjobs/oferta/'+oferta+'/';

        var modelOferta = new window.Oferta();
        modelOferta.url = urlLoginClientRecurs;
        modelOferta.fetch({
            beforeSend: sendAuthentication,
            error: function () {
                //alert("error al cargar la oferta");
                loadingSpinner("off");
            },
            success: function (model, response) {
                //alert('success get oferta');
                //alert(JSON.stringify(model));
                //alert('aixo ho guardo a local storage');
                window.localStorage.setItem("offer", JSON.stringify(model));
                app.navigate("modificarOfertaClient", true);
            }
        });
    },

    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    }
});

window.OfertaLlistatItemView = Backbone.View.extend({

    tagName:"li",

    initialize: function () {},

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        return this;
    }
});

