window.PropostaClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #enviarProposta':'enviaProposta',
        'click #descarrega':'descarregaFitxer',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'click #comments3':'comments3',
        
    	'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader',

        'click #ampliar':'ampliar'
    },

    ampliar: function(e){
        showImage(e.currentTarget.attributes[1].value);
    },
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },

   
    renderSlider: function ( e ) {
        
        var modelProposta = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        var load = false;
        //alert(JSON.stringify(modelProposta.get("profesional")));
        if(modelProposta.get("profesional").logotip!=null){
            //alert(modelProposta.get("profesional").logotip);
            $('#imatgeOferta').attr("src",modelProposta.get("profesional").logotip).load(function(){
               load = true;
            });
        }else{
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        if(load == false){
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        $('#titulOferta').text(modelProposta.get("oferta").resum);
        $('#nom').text(modelProposta.get("profesional").user.username);
        $('#empresa').text(modelProposta.get("profesional").empresa);
        $('#descripcioProposta').val(modelProposta.get("descripcio"));
        $('#preuProposta').val(modelProposta.get("preuHora"));
        $('#preu').text(modelProposta.get("preuHora"));
        $('#minim').val(modelProposta.get("preuminim"));
        $('#maxim').val(modelProposta.get("preumaxim"));
        $('#justificacioProposta').val(modelProposta.get("justificacioPressupost"));
        if(modelProposta.get("materialInclos")){
            $('#materialProposta').val('No necesita material');
        }else{
            $('#materialProposta').val(modelProposta.get("descripcioMaterial"));
        }
        if(modelProposta.get("profesional").imatges.length>0){
            //Main Swiper
            swiperDyn = $('#galeria').swiper({
                pagination:'.pagination-sd'
            });
            $('#galeria').css({'display':'block'});
            for(var i=0;i<modelProposta.get("profesional").imatges.length;i++){
                var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+modelProposta.get("profesional").imatges[i].imatges+'"/>');
                newSlide.append();
            }
        }
        galeriaReady=false;
        if(modelProposta.get("profesional").acreditacions.length>0){
            galeriaReady=true;
            swiperDynAcred = $('#galeriaAcred').swiper({
                pagination:'.pagination-sdAcred'
            });
            for(var i=0;i<modelProposta.get("profesional").acreditacions.length;i++){
                var newSlide = swiperDynAcred.createSlide('<img id="ampliar" src="'+modelProposta.get("profesional").acreditacions[i].acreditacionsProfesionals+'"/>');
                newSlide.append();
            }
            $('#galeriaAcred').css({'display':'none'});
        }else{
            $('#galeriaAcred').css({'display':'none'});
            $('.esquerraProp').css({'background':'rgba(57,57,57,0.1)'});
            $('.esquerraProp div').css({'color':'#bababa'});
            $('.esquerraProp img').attr("src","img/certificado_2.png");
            $('.esquerraProp').removeClass('btnHover');
        }
        if(modelProposta.get("estatAcceptacio")==1){
            $(".candidata").text("candidata");
            $('.dretaProp').css({'background':'rgba(97, 189, 222, 0.2)'});
            $('.dretaProp').removeClass('btnHover');
        }

        setTimeout(function(){
            $(".botoInfo").each(function(){
                var thisHeight = $(this).outerHeight()-$(this).children("img").outerHeight();
                //$(this).children("img").animate({marginTop: thisHeight/2 + 'px'}, 100 );
                //$(this).children("div").animate({marginTop: thisHeight/2 + 'px'}, 100 );
                $(this).children("img").css('margin-top', thisHeight/2 + 'px', 'important');
                $(this).children("div").css('margin-top', thisHeight/2 + 'px', 'important');
            });
        }, 100);

        $(function(){
            $("textarea").each(function(){
                this.style.height = "1px";
                this.style.height = (18+this.scrollHeight)+"px";
            });
        });
        
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });

        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    },

    descarregaFitxer: function ( e ) {
        var modelProposta = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        
        if(modelProposta.get("profesional").acreditacions.length>0){
            if(galeriaReady){
                $('#galeriaAcred').css({'display':'block'});
                galeriaReady=false;
            }else{
                $('#galeriaAcred').css({'display':'none'});
                galeriaReady=true;
            }
        }
    },

    enviaProposta: function ( e ) {
        loadingSpinner("on");
        var propostaModel = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        if($(e.currentTarget).attr('data-estat')==1 && propostaModel.get("estatAcceptacio")==1){
            loadingSpinner("off");
        }else{
            var propostaValues = ({
                id: propostaModel.get("id"),
                profesional: propostaModel.get("profesional").resource_uri,
                oferta: propostaModel.get("oferta").resource_uri,
                descripcio: propostaModel.get("descripcio"),
                justificacioPressupost: propostaModel.get("justificacioPressupost"),
                preumaxim: propostaModel.get("preumaxim"),
                preuminim: propostaModel.get("preuminim"),
                preuHora: propostaModel.get("preuHora"),
                materialInclos: propostaModel.get("materialInclos"),
                descripcioMaterial: propostaModel.get("descripcioMaterial"),
                estatAcceptacio: parseInt($(e.currentTarget).attr('data-estat'))
            });

            var propostaModel = new window.Proposta(propostaValues);
            propostaModel.url = window.IPServidor + '/api/buonjobs/proposta/'+ propostaModel.get("id") + '/';

            propostaModel.save( {} , {
                beforeSend: sendAuthentication,
                error: function(model, response) {
                    //alert(response.responseText);
                    //alert(response.status);
                    loadingSpinner("off");
                },
                success: function(model, response) {
                    if($(e.currentTarget).attr('data-estat')==2){
                        //customAlert("propuesta contratada!",0,1500,"",2,false);
                        customAlert("propuesta contratada!",0,2000,"",2,false);
                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ContractarProposta - Proposta Client", "Click", "Proposta Client", 1);
                        }
                    }else{
                        window.localStorage.setItem("propose",JSON.stringify(model));
                        $(".candidata").text("candidata");
                        $('.dretaProp').css({'background':'rgba(97, 189, 222, 0.2)'});
                        $('.dretaProp').removeClass('btnHover');
                        //customAlert("propuesta añadida a candidatas!",0,1500,"",1,false);
                        customAlert("propuesta añadida a candidatas!",0,2000,"",1,false);
                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button PropostaCandidata - Proposta Client", "Click", "Proposta Client", 1);
                        }
                    }
                },
            });
        }
    },

    comments1: function( e ) {
        customAlert("Descripción de la propuesta realizada por el profesional",1,0,"",3,false);
    },

    comments2: function( e ) {
        customAlert("El presupuesto puede variar entre el mínimo y el máximo especificado",1,0,"",3,false);
    },

    comments3: function( e ) {
        customAlert("El material necesario para realizar tu oferta",1,0,"",3,false);
    }
});
