window.OfertaClientView = Backbone.View.extend({

    initialize: function () {
        this.model = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
        _.bindAll(this,"render","renderSlider");
        this.render();
    },

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #crearOfertaButton':'comprovaDadesOferta',
        'click #back_boto':'vesAPantallaAnterior',
        'click #boto_afegir_foto':'getFoto',
        'click #boto_mapa':'addMarkerForAddress',
        'click #boto_afegir_fotos':'canviarBotonsAfegirFotos',
        'click #boto_categoria':'mostraCategoria',
        'click #categoria':'fixaCategoria',
        'click #refreshMap':'addMarkerForAddress',
        'click #crearDireccio':'crearDireccio',
        'click #eliminarOferta':'eliminarOferta',
        'click #deletePhoto':'eliminaFoto',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'click #comments3':'comments3',
        'click #comments4':'comments4',
        'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader',
        'click #ampliar':'ampliar'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    ampliar: function(e){
        showImage(e.currentTarget.attributes[1].value);
    },

    renderSlider: function ( e ) {
        $('#formulariCrearOferta').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            loadingSpinner("on");
    
            if($("#formulariCrearOferta").valid()){
                if(categoria=="undefined"){
                    $('html, body').animate({
                        scrollTop: $('.parent').offset().top
                    }, 1000);
                    $('#errorVerificarCategoria').css({'display':'block'});
                    loadingSpinner("off");
                }else{
                    var entra=false;
                    if($('input.unique').filter(':checked').attr("id")!=undefined){
                        entra=true;
                    }
                    if(entra){
                        var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                        var direccions = modelClient.get("direccio");
                        for(var i=0;i<direccions.length;i++){
                            if(direccions[i].id==$('input.unique').filter(':checked').attr("id")){
                                resultDireccio = direccions[i];
                            }
                        }
                        comprovaDades(resultDireccio);
                    }else{
                        if(!dropdownDireccion){
                            dropdownDireccion=true;
                            $('#dropdownDireccion').css({'height':$('#dropdownDireccion')[0].scrollHeight});
                            $("#dropButtonDireccion").attr("src","img/arrow_down.png");
                        }
                        $("html, body").animate({ scrollTop: $(".parentDireccion").offset().top }, 1000);
                        $('#errorEscollirDireccio').css({'display':'block'});
                        loadingSpinner("off");
                    }
                }
            }else{
                loadingSpinner("off");
            }

            function comprovaDades(resultDireccio){

                if(deleteFotos.length>0){
                    var successFotos = 0;
                    for(var i=0;i<deleteFotos.length;i++){
                    	
                         var ofertaFotoValues = ({
                             id: deleteFotos[i]
                         });
                    	var modelOfertaFoto = new window.FotoOferta(ofertaFotoValues);
                    	 modelOfertaFoto.url = window.IPServidor + '/api/buonjobs/fotoOferta/'+deleteFotos[i]+'/';
                        modelOfertaFoto.destroy({
                            success: function(){
                                successFotos++;
                                if(successFotos==deleteFotos.length){
                                    keepGoing();
                                }
                            },
                            error: function(model, response) {
                                loadingSpinner("off");
                            }
                        });
                    }
                }else{
                    keepGoing();
                }

                function keepGoing(){

                    var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                    var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
                    var ofertaValues = ({
                        id: modelOferta.get("id"),
                        client: modelClient.get("resource_uri"),
                        resum: $("#resum").val(),
                        descripcio: $("#descripcio").val(),
                        categoria: categoria,
                        direccio: resultDireccio.resource_uri,
                        imatges: window.fotoOfertaAPIURL,
                        urgent_flag: $('#urgent').prop('checked')
                    });
                    //alert(JSON.stringify(ofertaValues));
                    var ofertaModel = new window.Oferta (ofertaValues);
                    ofertaModel.url = window.IPServidor + modelOferta.get("resource_uri");
                    ofertaModel.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function(model, response) {
                            //alert(response.responseText);
                            loadingSpinner("off");
                        },
                        success: function(model, response) {
                            customAlert("Oferta modificada!",0,2000,"",1,false);
                            if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarOferta - Oferta Client", "Click", "Oferta Client", 1);
                            }
                        }
                    });
                }
            }
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        time=1;
        returnedValue=false;
        booleaGeneral=false;
        dropdown=false;
        dropdownLocation=false;
        dropdownDireccion=false;
        window.deleteFotos = [];

        var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
        var direccions = modelClient.get("direccio");
        for(var i=0;i<direccions.length;i++){
            if(direccions[i].id==this.model.attributes.direccio.id){
                $("#direccionsExistents").append("<div class='direccions'><input type='checkbox' class='unique' id='"+direccions[i].id+"' checked><label for='"+direccions[i].id+"''></label><div class='infoDireccio "+direccions[i].id+"'>"+direccions[i].carrer+", "+direccions[i].numero+", "+direccions[i].ciutat+", "+direccions[i].codipostal+"</div><img src='img/button_login_cliente.png'></div>");
            }else{
                $("#direccionsExistents").append("<div class='direccions'><input type='checkbox' class='unique' id='"+direccions[i].id+"'><label for='"+direccions[i].id+"''></label><div class='infoDireccio "+direccions[i].id+"'>"+direccions[i].carrer+", "+direccions[i].numero+", "+direccions[i].ciutat+", "+direccions[i].codipostal+"</div><img src='img/button_login_cliente.png'></div>");
            }
            $('.'+direccions[i].id).css('margin-top', -($('.'+direccions[i].id).outerHeight()/2) + 'px', 'important');
        }

        $('input.unique').click(function() {
            $('input.unique').filter(':checked').not(this).removeAttr('checked');
        });
        
        //Definim les normes a validar
        $("#formulariCrearOferta").validate({
            rules: {
                resum: {
                    required: true,
                    maxlength: 25
                },
                descripcio: {
                    required: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        $("#formulariNovaDireccio").validate({
            rules: {
                ciutat: "required",
                carrer: "required",
                codiPostal: {
                    required: true,
                    digits: true
                },
                numero: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        //alert(this.model.attributes.imatges.length);
        if(this.model.attributes.imatges.length>0){
            window.fotoOfertaAPIURL = [];
            $('#galeria').css({'display':'block'});
            //Main Swiper
            swiperDyn = $('.swiper-dynamic').swiper({
                pagination:'.pagination-sd'
            });
            for(var i=0;i<this.model.attributes.imatges.length;i++){
                var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+ this.model.attributes.imatges[i].imatgeOferta+'"/>');
                newSlide.append();
                //alert(this.model.attributes.imatges[i].resource_uri);
                window.fotoOfertaAPIURL.push(this.model.attributes.imatges[i].resource_uri);
                time++;
            }
            $('#mainImage').attr("src",this.model.attributes.imatges[0].imatgeOferta);
        }else{
            $('#mainImage').attr("src","img/default_image.png");
        }

        categoria=this.model.attributes.categoria;
        $("a[data-categoria='reparacions']").text(categoria);
        $('#dropdown').height($('#DropContent a').outerHeight(true));
              
        $('#urgent').prop('checked', this.model.attributes.urgent_flag);
        

        loadingSpinner("off");
    },

    eliminaFoto: function ( e ) {

        $('.customAlert').css('width', $(window).width() + 'px', 'important');

        $('.alertMessage').text("Seguro que quieres eliminar la foto?");
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                   
                    time--;
                    var urlsplit = window.fotoOfertaAPIURL[swiperDyn.activeSlide].split("/");
                    deleteFotos.push(urlsplit[4]);
                    var index = window.fotoOfertaAPIURL.indexOf(swiperDyn.activeSlide);
                    window.fotoOfertaAPIURL.splice(index, 1);
                    swiperDyn.prependSlide(swiperDyn.slides[swiperDyn.activeSlide]);
                    swiperDyn.swipeTo(0);
                    swiperDyn.removeSlide(0);
                    if(swiperDyn.slides.length==1){
                        $('.pagination-sd').empty();
                    }
                    if(swiperDyn.slides.length==0){
                        $('#galeria').css({'display':'none'});
                    }
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });
      
    },

    fixaCategoria: function ( e ){
        if(dropdown){
            if($(e.currentTarget).attr('data-categoria')=="reparacions"){
                customAlert('ELECTRICISTAS, FONTANEROS, ALBAÑILES, CARPINTEROS, CERRAJERIA, ELECTRODOMESTICOS, TÉC. ELECTRODOMESTICOS, TV, EBANISTERIA, PINTORES, EMPAPELADORES... Y TODAS LAS ACTIVIDADES RELACIONADAS', 2, 0, '', 0, false, 'Reparaciones/reformas', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="asesorament"){
                customAlert('CONTABILIDAD, FISCAL, LABORAL, LEGAL, ABOGADOS, INGENIEROS, ARQUITECTOS, SEGUROS, COMERCIAL, MARQUETING... Y TODAS LAS ACTIVIDADES DE ASESORAMIENTO Y/O GESTION', 2, 0, '', 0, false, 'asesoramiento/gestión', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="informatica"){
                customAlert('PROGRAMACION, DESARROLLO, MANTENIMIENTO, INSTALACION, SOPORTE, REDES... Y TODAS LAS ACTIVIDADES PROPIAS DE LA INFORMATICA', 2, 0, '', 0, false, 'informática', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="formacio"){
                customAlert('IDIOMAS, MUSICA, COMERCIAL, REFUERZOS DE ASIGNATURAS, VOCAL... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL CONOCIMIENTO', 2, 0, '', 0, false, 'formación', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="arts"){
                customAlert('GRAFICO, PUBLICIDAD, ARQUITECTURA, WEB, INDUSTRIAL, TEATRAL, VIDEO, ACTORES... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL ARTE Y/O DISEÑO', 2, 0, '', 0, false, 'artes/diseño', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="automocio"){
                customAlert('MECANICA, COMPRA/VENTA... Y TODAS LAS ACTIVIDADES RELACIONADAS CON MOTOS, CAMIONES Y COCHES', 2, 0, '', 0, false, 'automoción', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="serveis"){
                customAlert('CUIDADO ANCIANOS, LIMPIEZA, CANGUROS, AUPAIRS, JARDINERIA, CUIDADO INFANTIL, MASAJISTAS, FISIOTERAPEUTAS, MONTADORES MOBILIARIO... Y TODAS LAS ACTIVIDADES RELACIONADAS CON LOS SERVICIOS HOGAR', 2, 0, '', 0, false, 'servicios hogar', true, e);
            }
        }else{
            dropdown=true;
            $('#dropdown').animate({height:$('#DropContent').outerHeight()});
            $("#dropButton").attr("src","img/arrow_down.png");
            $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
            $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
        }
    },

    mostraCategoria: function( e ){
        if($(e.currentTarget).attr('data-dropdown')=="categoria"){
            if(dropdown){
                categoria="undefined";
                dropdown=false;
                $('#dropdown').animate({height:0});
                $("#dropButton").attr("src","img/button_login_cliente.png");
            }else{
                dropdown=true;
                $('#dropdown').animate({height:$('#DropContent').outerHeight(true)});
                $("#dropButton").attr("src","img/arrow_down.png");
                $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
                $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
            }
        }
        if($(e.currentTarget).attr('data-dropdown')=="direccion"){
            if(dropdownDireccion){
                dropdownDireccion=false;
                $('#dropdownDireccion').animate({height:0});
                $("#dropButtonDireccion").attr("src","img/button_login_cliente.png");
            }else{
                dropdownDireccion=true;
                $('#dropdownDireccion').animate({height:$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
                $("#dropButtonDireccion").attr("src","img/arrow_down.png");
                $("html, body").animate({ scrollTop: $(".parentDireccion").offset().top }, 1000);
            }
        }
        if($(e.currentTarget).attr('data-dropdown')=="location"){
            if(dropdownLocation){
                dropdownLocation=false;
                $('#dropdownLocation').animate({height:0});
                $("#dropButtonLocation").attr("src","img/button_login_cliente.png");
                $('#dropdownDireccion').animate({height:$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
            }else{
                dropdownLocation=true;
                $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
                $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
                $("#dropButtonLocation").attr("src","img/arrow_down.png");
                $("html, body").animate({ scrollTop: $(".parentLocation").offset().top }, 1000);
            }
        }
    },

    addMarkerForAddress: function( e ){
        if($("#formulariNovaDireccio").valid()){
            //console.log("Entering addMarkerForAddress()");
            var address = $("#carrer").val() +', '+ $("#numero").val() +', '+ $("#ciutat").val() +', '+ $("#codiPostal").val();
            //console.log(address);

            getLatLangFromAddress(address);
        }else{
            $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
            $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
            $("#formulariNovaDireccio").change(function(){
                //console.log("hola");
                $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
                $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
            });
        }
        function getLatLangFromAddress(address){
            //console.log("Entering getLatLangFromAddress()");
            var geocoder = new google.maps.Geocoder();
            geocoder.geocode( { 'address': address}, function(results, status) {

                if (status == google.maps.GeocoderStatus.OK) {
                    returnedValue =results[0].geometry.location;
                    //console.log("Address found is " + returnedValue);

                    booleaGeneral=true;

                    $('#wrapperMap2').css({'display':'block'});
                    $('.refreshMap').css({'display':'block'});
                    
                    $('#boto_mapa').css({'display':'none'});
                    $('#errorVerificarMapa').css({'display':'none'});

                    //carreguem mapa
                    //console.log("Entering displayCurrentLocation()");
                    try{
                        //console.log(returnedValue.lat());
                        var currentLocationLatAndLong = new google.maps.LatLng(returnedValue.lat(),returnedValue.lng());
                        //console.log(currentLocationLatAndLong);
                        var mapOptions ={
                            zoom:15,
                            center:currentLocationLatAndLong,
                            mapTypeId: google.maps.MapTypeId.ROADMAP
                        };
                        var mapDiv = document.getElementById("map");
                        map = new google.maps.Map(mapDiv,mapOptions);
                    }catch(e){
                        //console.log("Error occured in ConsultantLocator.displayMap() " + e);
                    }
                    //console.log("Exiting displayCurrentLocation()");

                    addMarker(returnedValue);

                    $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
                    $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
                }else{
                    //alert("Geocode was not successful for the following reason: " + status);
                }
            });
            //console.log("Exiting getLatLangFromAddress()");
        }

        function addMarker(latLng){
            //console.log("Entering addMarker()");
            var markerOptions = new google.maps.Marker({
                map: map,
                position: latLng,
                clickable:true
            });
            var marker = new google.maps.Marker(markerOptions);
            var infoWindowOptions = {
                content: address,
                position: latLng
            };
            var infoWindow = new google.maps.InfoWindow(infoWindowOptions);
            google.maps.event.addListener(marker, "click", function(){
                infoWindow.open(map);
                //console.log("open map");
            });
            //console.log("Exiting addMarker()");
        }
    },

    canviarBotonsAfegirFotos: function ( e ) {
        $('#boto_afegir_fotos_pressed').css({'display':'block'});
        $('#boto_afegir_fotos').css({'display':'none'});
    },

    vesAPantallaAnterior: function ( e ) {
        //console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    },

    getFoto: function( e ) {
        e.preventDefault();

        //amb aquesta variable definim si volem agafar la foto de la galeria o el móbil
        if($(e.currentTarget).attr('data-foto')=="camera"){
            var definedSourceType = navigator.camera.PictureSourceType.CAMERA;
        }else{
            var definedSourceType = navigator.camera.PictureSourceType.PHOTOLIBRARY;
        }

        //console.log("entro al fes foto");
        
        navigator.camera.getPicture(
            function onPhotoURISuccess(imageURI) {
                
                loadingSpinner("on");
                var options = new FileUploadOptions();
                options.fileKey="file";

                var fileName = "" + (new Date()).getTime() + ".jpg"; // consider a more reliable way to generate unique ids
                options.fileName =   fileName;
                options.mimeType="image/jpeg";
                //console.log(options.fileName);

                var tries = 0;
                var ft = new FileTransfer();
                
                options.chunkedMode=false;
             

                var signingURI = window.IPServidor+ "/signing";
                
                $.ajax({url: signingURI, dataType: "json", type: "GET"})
                .done(function (data) {
	        	
	        	    options.params = {
	                    "key":  options.fileName,
	                    "AWSAccessKeyId": data.awsKey,
	                    "acl": "public-read",
	                    "policy": data.policy,
	                    "signature": data.signature,
	                    "Content-Type": "image/jpeg"
	                };
	                
               	    ft.upload(imageURI, s3URI, win, fail, options, false);
                })
                .fail(function (error) {
                	customAlert("Ha fallado la connexión con el servidor. Intentalo de nuevo.",0,1500,"",3,false);
                    loadingSpinner("off");
                });
      
                //options.params = params;
                //ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, true);
                //ft.upload(imageURI, s3URI, win, fail, options, true);
                
                function win(r) {
                   
                    loadingSpinner("off");
                    //var resposta = JSON.parse(r.response);
                    
                    if(time==1){
                        $('#galeria').css({'display':'block'});
                        window.fotoOfertaAPIURL = [];
                    }
                    var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+imageURI+'"/>');
                    newSlide.append();
                    //alert(JSON.stringify(r));
                    time++;
                    var fotoOfertaValues = ({
                        imatgeOferta: options.fileName
                        //imatgeOferta: "Ofertes/"+resposta.message
                    });

                    var modelFotoOferta = new window.FotoOferta(fotoOfertaValues);
                    modelFotoOferta.url = window.IPServidor + '/api/buonjobs/fotoOferta/';
                    modelFotoOferta.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function(model, response) {
                            //alert(response.responseText);
                            loadingSpinner("off");
                        },
                        success: function(model, response) {
                            ////console.log("resposta uri fotos oferta: "+response['resource_uri']);
                            window.fotoOfertaAPIURL.push(response['resource_uri']);
                        }
                    });
                }
                function fail(error) {
                    if(tries<3){
                        tries++;
                        options.chunkedMode=false;
                        ft.upload(imageURI, s3URI, win, fail, options, true);
                        //ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, true);
                    }else{
                        loadingSpinner("off");
                        customAlert("Ha fallado la subida",0,3000,"",3,false);
                    }
                }
            },
            function onFail(message) {
                if(message!="Selection cancelled." && message!="Camera cancelled."){
                    //alert('Ocurrió un error: ' + message);
                }
            },
            
            { quality: 40, sourceType: definedSourceType, encodingType: Camera.EncodingType.JPEG, targetWidth: 560,targetHeight: 560, correctOrientation: true}
        );
    },

    crearDireccio: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");

        if($("#formulariNovaDireccio").valid()){
            if(!booleaGeneral){
                $('html, body').animate({
                    scrollTop: $('.titleRegistre').offset().top
                }, 1000);
                $('#errorVerificarMapa').css({'display':'block'});
                $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
                $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
                /*setTimeout(function(){
                    $('#dropdownLocation').css({'height':$('#dropdownLocation')[0].scrollHeight+20});
                    $('#dropdownDireccion').css({'height':$('#dropdownDireccion')[0].scrollHeight+20});
                }, 100);*/
                loadingSpinner("off");
            }else{
                comprovaDadesDireccio();
            }
        }else{
            $('#dropdownLocation').animate({height:$('#DropLocContent').outerHeight(true)});
            $('#dropdownDireccion').animate({height:$('#DropLocContent').outerHeight(true)+$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
            loadingSpinner("off");
        }

        function comprovaDadesDireccio(){
            var direccioValues = ({
                numero: $("#numero").val(),
                carrer: $("#carrer").val(),
                ciutat: $("#ciutat").val(),
                codipostal: $("#codiPostal").val(),
                latitud: returnedValue.lat(),
                longitud: returnedValue.lng()
            });

            var modelDireccio = new window.Direccio(direccioValues);
            modelDireccio.url = window.IPServidor + '/api/buonjobs/direccio/';
            modelDireccio.save( {} , {
                beforeSend: sendAuthentication,
                error: function(model, response) {
                    //alert(response.responseText);
                    loadingSpinner("off");
                },
                success: function(model, response) {
                    var direccioAPIURL = response.resource_uri;
                    var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                    var direccions = modelClient.get("direccio");
                    direccions.push(direccioAPIURL);
                    var urlClient = modelClient.get("resource_uri");

                    var clientValues = ({
                        id: modelClient.get("id"),
                        user: modelClient.get("user").resource_uri,
                        telefon: modelClient.get("telefon"),
                        nom: modelClient.get("nom"),
                        direccio: direccions
                    });
                    
                    var modelClient = new window.Client (clientValues);
                    modelClient.url = window.IPServidor + urlClient;
                    modelClient.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function (model, response) {
                            //console.log(response.responseText);
                            loadingSpinner("off");
                        },
                        success: function (model, response) {
                            model.fetch({
                                beforeSend: sendAuthentication,
                                success: function (model, response) {
                                    window.localStorage.setItem("user", JSON.stringify(model));
                                    var direccions = model.get("direccio");
                                    $("#direccionsExistents").prepend("<div class='direccions'><input type='checkbox' class='unique' id='"+direccions[0].id+"'><label for='"+direccions[0].id+"''></label><div class='infoDireccio "+direccions[0].id+"'><h3>"+direccions[0].carrer+", "+direccions[0].numero+", "+direccions[0].ciutat+", "+direccions[0].codipostal+"</h3></div><img src='img/button_login_cliente.png'></div>");
                                    $('.'+direccions[0].id).css('margin-top', -($('.'+direccions[0].id).outerHeight()/2) + 'px', 'important');
                                    $('input.unique').filter(':checked').not('.'+direccions[0].id).removeAttr('checked');
                                    $('.'+direccions[0].id).attr('checked','checked');
                                    customAlert("Dirección añadida!",0,2000,"",3,false);
                                    dropdownLocation=false;
                                    $('input.unique').click(function() {
                                        $('input.unique').filter(':checked').not(this).removeAttr('checked');
                                    });
                                    $('#dropdownLocation').animate({height:0});
                                    $("#dropButtonLocation").attr("src","img/button_login_cliente.png");
                                    $('#dropdownDireccion').animate({height:$('#direccionsExistents').outerHeight(true)+$('#boto_categoria').outerHeight(true)});
                                    $("html, body").animate({ scrollTop: $(".parentDireccion").offset().top }, 1000, function(){
                                        $('#wrapperMap2').css({'display':'none'});
                                        $('.refreshMap').css({'display':'none'});
                                        
                                        $('#boto_mapa').css({'display':'block'});
                                        $('#errorVerificarMapa').css({'display':'none'});
                                    });
                                    loadingSpinner("off");
                                }
                            });
                        }
                    });
                }
            });
        }
    },

    comprovaDadesOferta: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
    
        if($("#formulariCrearOferta").valid()){
            if(categoria=="undefined"){
                $('html, body').animate({
                    scrollTop: $('.parent').offset().top
                }, 1000);
                $('#errorVerificarCategoria').css({'display':'block'});
                loadingSpinner("off");
            }else{
                var entra=false;
                if($('input.unique').filter(':checked').attr("id")!=undefined){
                    entra=true;
                }
                if(entra){
                    var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                    var direccions = modelClient.get("direccio");
                    for(var i=0;i<direccions.length;i++){
                        if(direccions[i].id==$('input.unique').filter(':checked').attr("id")){
                            resultDireccio = direccions[i];
                        }
                    }
                    comprovaDades(resultDireccio);
                }else{
                    if(!dropdownDireccion){
                        dropdownDireccion=true;
                        $('#dropdownDireccion').css({'height':$('#dropdownDireccion')[0].scrollHeight});
                        $("#dropButtonDireccion").attr("src","img/arrow_down.png");
                    }
                    $("html, body").animate({ scrollTop: $(".parentDireccion").offset().top }, 1000);
                    $('#errorEscollirDireccio').css({'display':'block'});
                    loadingSpinner("off");
                }
            }
        }else{
            loadingSpinner("off");
        }

        function comprovaDades(resultDireccio){

            if(deleteFotos.length>0){
                var successFotos = 0;
                for(var i=0;i<deleteFotos.length;i++){

                    var modelOfertaFoto = new window.FotoOferta();
                    modelOfertaFoto.url = window.IPServidor + '/api/buonjobs/fotoOferta/'+deleteFotos[i]+'/';
                    modelOfertaFoto.destroy({
                        success: function(){
                            successFotos++;
                            if(successFotos==deleteFotos.length){
                                keepGoing();
                            }
                        },
                        error: function(model, response) {
                            loadingSpinner("off");
                        }
                    });
                }
            }else{
                keepGoing();
            }

            function keepGoing(){

                var modelClient = new window.Client(JSON.parse(window.localStorage.getItem("user")));
                var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
                var ofertaValues = ({
                    id: modelOferta.get("id"),
                    client: modelClient.get("resource_uri"),
                    resum: $("#resum").val(),
                    descripcio: $("#descripcio").val(),
                    categoria: categoria,
                    direccio: resultDireccio.resource_uri,
                    imatges: window.fotoOfertaAPIURL,
                    urgent_flag: $('#urgent').prop('checked')
                });
                //alert(JSON.stringify(ofertaValues));
                var ofertaModel = new window.Oferta (ofertaValues);
                ofertaModel.url = window.IPServidor + modelOferta.get("resource_uri");
                ofertaModel.save( {} , {
                    beforeSend: sendAuthentication,
                    error: function(model, response) {
                        //alert(response.responseText);
                        loadingSpinner("off");
                    },
                    success: function(model, response) {
                        customAlert("Oferta modificada!",0,2000,"",1,false);
                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ModificarOferta - Oferta Client", "Click", "Oferta Client", 1);
                        }
                    }
                });
            }
        }
    },

    eliminarOferta: function ( e ) {
        e.preventDefault();

        $('.customAlert').css('width', $(window).width() + 'px', 'important');

        $('.alertMessage').text("Seguro que quieres eliminar la oferta?");
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    loadingSpinner("on");
                    closePage();
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });

        function closePage(){
            loadingSpinner("on");

            var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
            var ofertaValues = ({
                id: modelOferta.get("id")
            });

            var ofertaModel = new window.Oferta (ofertaValues);
            ofertaModel.url = window.IPServidor + modelOferta.get("resource_uri");
            ofertaModel.destroy({
                beforeSend: sendAuthentication,
                error: function() {
                    //alert("error al borrar la oferta!");
                    loadingSpinner("off");
                },
                success: function() {
                    customAlert("Oferta borrada!",0,2000,"",1,false);

                    if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                        gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button EliminarOferta - Oferta Client", "Click", "Oferta Client", 1);
                    }
                }
            });
        }
    },

    comments1: function( e ) {
        customAlert("Especifica de una manera muy corta de que se trata el trabajo",1,0,"",3,false);
    },

    comments2: function( e ) {
        customAlert("Detalla al máximo el trabajo, si se trata de una reforma infórmate de los materiales que quieres y decide si quieres ser tú quien los compre",1,0,"",3,false);
    },

    comments3: function( e ) {
        customAlert("Haz fotos y publica tanta información como puedas para que los presupuestos que recibas se ajusten más a tus necesidades",1,0,"",3,false);
    },

    comments4: function( e ) {
        customAlert("Estos trabajos necesitan realizarse en un período de 24h, prioriza la oferta para que los profesionales acudan lo antes posible",1,0,"",3,false);
    }
});
