window.PropostaProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        //alert('entrem a proposta professional');
        $(this.el).html(this.template());
        $(this.el).show();
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #acceptarProposta':'comprovaProposta',
        'click #enviarProposta':'enviaProposta',
        'click #modificarProposta':'modificaProposta',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'click #comments3':'comments3',
        
    	'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },

    renderSlider: function ( e ) {
        $('#formProposta').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            if($("#formProposta").valid()){
                var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
                $('#primeraPantalla').css({'display':'none'});
                $('#informacioServei').text(modelOferta.get("descripcio"));
                if(modelOferta.get("imatges").length>0){
                    $('#imatgeOferta').attr("src",modelOferta.get("imatges")[0].imatgeOferta);
                }else{
                    $('#imatgeOferta').attr("src","img/default_image.png");
                }
                $('#titulOferta').text(modelOferta.get("resum"));
                $('#categoria').text(modelOferta.get("categoria"));
                $('#carrer').text(modelOferta.get("direccio").carrer);
                $('#ciutatCP').text(modelOferta.get("direccio").ciutat+', '+modelOferta.get("direccio").codipostal);
                $('#pais').text(modelOferta.get("direccio").pais);
                $('#descripcioProposta').text('Descripción: '+$('#descripcio').val());
                $('#preuProposta').text('Precio Hora: '+$('#preu').val()+'€/hora');
                $('#minMaxProposta').text('con un mínimo de '+$('#minim').val()+'€ y un máximo de '+$('#maxim').val()+'€');
                $('#justificacioProposta').text('Justificación del presupuesto: '+$('#justificacio').val());
                if($('#material').val()==""){
                    $('#materialProposta').text('Material: ya incluido');
                }else{
                    $('#materialProposta').text('Material: '+$('#material').val());
                }
                $('#segonaPantalla').css({'display':'block'});
            }
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });

        $("#siMaterial").change(function() {
        	window.scrollTo(0,0);
            
        	document.activeElement.blur();
            $("input").blur();
        	
            this.addclassHeader();
            
            if(this.checked) {
                $('#material').attr("disabled", true);
            }else{
                $('#material').attr("disabled", false);
            }
        });
        
        //Definim les normes a validar
        $("#formProposta").validate({
            rules: {
                preu: {
                    required: true,
                    number: true
                },
                minim: {
                    required: true,
                    number: true
                },
                maxim: {
                    required: true,
                    number: true
                },
                descripcio: {
                    required: true,
                    //minlength: 30
                },
                justificacio: {
                    required: true,
                    //minlength: 30
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                if(element.attr('data-error')=="grup"){
                    error.insertAfter(element.parent());
                }else{
                    error.insertAfter(element);
                }
                error.addClass('campNoValid');
            }
        });
        loadingSpinner("off");
    },
    vesAPantallaAnterior: function ( e ) {
        if($('#primeraPantalla').css('display')=='block'){
            loadingSpinner("on");
            window.history.back();
        }else{
            $('#segonaPantalla').css({'display':'none'});
            $('#primeraPantalla').css({'display':'block'});
        }
    },
    comprovaProposta: function ( e ) {
        if($("#formProposta").valid()){
            var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
            $('#primeraPantalla').css({'display':'none'});
            $('#informacioServei').text(modelOferta.get("descripcio"));
            if(modelOferta.get("imatges").length>0){
                $('#imatgeOferta').attr("src",modelOferta.get("imatges")[0].imatgeOferta);
            }else{
                $('#imatgeOferta').attr("src","img/default_image.png");
            }
            $('#titulOferta').text(modelOferta.get("resum"));
            $('#categoria').text(modelOferta.get("categoria"));
            $('#carrer').text(modelOferta.get("direccio").carrer);
            $('#ciutatCP').text(modelOferta.get("direccio").ciutat+', '+modelOferta.get("direccio").codipostal);
            $('#pais').text(modelOferta.get("direccio").pais);
            $('#descripcioProposta').text('Descripción: '+$('#descripcio').val());
            $('#preuProposta').text('Precio Hora: '+$('#preu').val()+'€/hora');
            $('#minMaxProposta').text('con un mínimo de '+$('#minim').val()+'€ y un máximo de '+$('#maxim').val()+'€');
            $('#justificacioProposta').text('Justificación del presupuesto: '+$('#justificacio').val());
            if($('#material').val()==""){
                $('#materialProposta').text('Material: ya incluido');
            }else{
                $('#materialProposta').text('Material: '+$('#material').val());
            }
            $('#segonaPantalla').css({'display':'block'});
        }
    },
    modificaProposta: function ( e ) {
        $('#segonaPantalla').css({'display':'none'});
        $('#primeraPantalla').css({'display':'block'});
    },
    enviaProposta: function ( e ) {
        loadingSpinner("on");
        var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
        var modelProfesional = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
        var propostaValues = ({
            profesional: modelProfesional.get("resource_uri"),
            oferta: '/api/buonjobs/oferta/' + modelOferta.get("id") +'/',
            descripcio: $('#descripcio').val(),
            justificacioPressupost: $('#justificacio').val(),
            preumaxim: parseFloat($('#maxim').val()),
            preuminim: parseFloat($('#minim').val()),
            preuHora: parseFloat($('#preu').val()),
            materialInclos: $('#siMaterial').prop('checked'),
            descripcioMaterial: $('#material').val(),
            pagada: true
        });

        var propostaModel = new window.Proposta(propostaValues);
        //propostaModel.url = window.IPServidor + '/api/buonjobs/proposta/?propostaPagada=true';
        propostaModel.url = window.IPServidor + '/api/buonjobs/proposta/';

        var dataProposta = propostaModel.toJSON();
     
        propostaModel.save(dataProposta, {
            beforeSend: sendAuthentication,
            error: function(model, response) {
                if (response.status == 400){
                	customAlert(response.responseText,0,3000,"",2,false);
                }else{
                 	customAlert("Se ha producido un error en el servidor",0,3000,"",2,false);
                   	
                }
             	
                loadingSpinner("off");
            },
            success: function(model, response) {
                //window.localStorage.removeItem("offer");
                customAlert("propuesta creada!",0,2000,"",5,false);
                if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                    gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button CrearProposta - Proposta Professional", "Click", "Proposta Professional", 1);
                }
            },
        });
    },

    comments1: function( e ) {
    	document.activeElement.blur();
        $("input").blur();
        this.addclassHeader();
        customAlert("Cuanto más personalizado detallado y profesional sea el presupuesto, mayores son las posibilidades de éxito",1,0,"",3,false);
    },

    comments2: function( e ) {
    	document.activeElement.blur();
        $("input").blur();
        this.addclassHeader();
        customAlert("La primera impresión siempre cuenta y el presupuesto será tu primer contacto con el cliente",1,0,"",3,false);
    },

    comments3: function( e ) {
    	document.activeElement.blur();
        $("input").blur();
        this.addclassHeader();
        customAlert("Define si ya tienes todo el material que necesitas para realizar el trabajo o si tendrían que facilitartelo",1,0,"",3,false);
    }
});