window.PropostesProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render:function (eventName) {

        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #proposta':'vesSeguentPantalla'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {

        if(estatAcceptacio==2){
            $('.header_titol p').text("propuestas aceptadas");
        }else if(estatAcceptacio==3){
            $('.header_titol p').text("propuestas rechazadas");
        }else if(estatAcceptacio==4){
            $('.header_titol p').text("propuestas valoradas");
        }
        
        var content = $('ul');

        $.ajax({
            url: window.IPServidor + '/api/buonjobs/proposta/?estatAcceptacio='+window.estatAcceptacio,
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {

                var quantesPropostes = missatgeResposta.objects.length;
                var logoProfesional = "";

                var notificacions = JSON.parse(window.localStorage.getItem("notifications"));
                
                for(var i=0;i<quantesPropostes;i++) {

                    if(missatgeResposta.objects[i].oferta.imatges.length>0){
                        logoProfesional = missatgeResposta.objects[i].oferta.imatges[0].imatgeOferta;
                    }else{
                        logoProfesional = "img/default_image.png";
                    }
                    
                    var valuesPropostaLlistatModel = ({
                        id: missatgeResposta.objects[i].id,
                        nomprofesional: missatgeResposta.objects[i].profesional.nom,
                        empresa: missatgeResposta.objects[i].profesional.empresa,
                        logo: logoProfesional,
                        resumoferta: missatgeResposta.objects[i].oferta.resum,
                        estatAcceptacio: missatgeResposta.objects[i].estatAcceptacio
                    });
          
                    var modelAux = new window.PropostaModelLlistat(valuesPropostaLlistatModel);
                    content.append(new PropostesProfesionalItemView({model: modelAux}).render().el);

                    if(notificacions!=null){
                        var result = $.grep(notificacions.data, function(e){ 
                        console.log(e.idNotificacio+" = "+missatgeResposta.objects[i].id);
                        console.log(e.messageType+" = "+missatgeResposta.objects[i].estatAcceptacio); return (e.idNotificacio == missatgeResposta.objects[i].id && e.messageType == missatgeResposta.objects[i].estatAcceptacio); });
                        console.log(result);
                        if(result.length!=0){
                        	$('[data-proposta=' + missatgeResposta.objects[i].id + ']').removeClass('baseBackground');
                            $("[data-proposta='"+missatgeResposta.objects[i].id+"']").addClass('listSelected');
                        }
                    }
                }

                if(notificacions!=null){
                    window.localStorage.setItem("notifications", JSON.stringify(notificacions));
                }

                $('.btnHover').on('touchstart', function(e){
                    $(this).addClass('tapped');
                });
                $('.btnHover').on('touchend', function(e){
                    setTimeout(function(){
                        $('.btnHover').removeClass('tapped');
                    }, 200);
                });

                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat propostes fail");
                loadingSpinner("off");
            }
        });
    },

    vesSeguentPantalla: function ( e ) {
        loadingSpinner("on");
        var proposta = $(e.currentTarget).attr('data-proposta');
        var urlRecursProposta = window.IPServidor + '/api/buonjobs/proposta/'+proposta+'/';

        modelProposta = new window.Proposta();
        modelProposta.url = urlRecursProposta;
        modelProposta.fetch({
            beforeSend: sendAuthentication,
            error: function () {
                //alert("error al cargar la propuesta");
                loadingSpinner("off");
            },
            success: function (model, response) {
                var notificacions = JSON.parse(window.localStorage.getItem("notifications"));

                if(notificacions!=null){
                    var result = $.grep(notificacions.data, function(e){ return (e.idNotificacio == model.attributes.id && e.messageType == model.attributes.estatAcceptacio); });
                    console.log(result);
                    if(result.length!=0){
                        var index = notificacions.data.indexOf(result);
                        notificacions.data.splice(index, 1);
                        $.ajax({
                            url: window.IPServidor + '/api/buonjobs/notificacio/'+result[0].id+'/',
                            type:'DELETE',
                            dataType:'json',
                            beforeSend: sendAuthentication,
                            contentType:'application/json',
                            success:function (missatgeResposta) {
                                window.localStorage.setItem("notifications",JSON.stringify(notificacions));
                            },
                            error: function (errormessage) {
                                //alert("error");
                            }
                        });
                    }
                }
                window.localStorage.setItem("propose", JSON.stringify(model));
                console.log(model.get("estatAcceptacio"));
                if(model.get("estatAcceptacio")==4){
                    app.navigate("propostaValoradaClient", true);
                }else{
                    app.navigate("propostaAcepRech", true);
                }
            }
        });
    },

    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    }
});

window.PropostesProfesionalItemView = Backbone.View.extend({

    tagName:"li",

    initialize: function () {},

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        return this;
    }
});