window.RegistreClientView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #boto_registre_client':'peticioRegistreServer',
        'click #back_boto':'vesAPantallaAnterior',
        'click #link':'loadLink',

        'click #modificarProposta':'modificarRegistre',
        'click #enviarProposta':'enviarRegistre',
        
        'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    
    
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },
    renderSlider: function ( e ) {
        $('#formulariLoginClient').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            if($("#formulariLoginClient").valid()){
                $('#usuari2').val($('#usuari').val());
                $('#correu2').val($('#correu').val());
                $('#segonaPantalla').css({'display':'block'});
                $('#primeraPantalla').css({'display':'none'});
            }
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });

        //Definim les normes a validar
        $("#formulariLoginClient").validate({
            rules: {
                nom: "required",
                usuari: {
                    required: true,
                    minlength: 2
                },
                clau: {
                    required: true,
                    minlength: 5
                },
                clau2: {
                    required: true,
                    minlength: 5,
                    equalTo: "#clau"
                },
                correu: {
                    required: true,
                    email: true
                },
                telefon: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        loadingSpinner("off");
        
        /*if(bannerOn){
            $('.banner').css({'top':deviceHeight-50+'px'});
            _inmobi.getNewAd(document.getElementById('my-ad-slot'));
            $('.bannerSpace').css({'display':'block'});
        }*/
    },
    vesAPantallaAnterior: function ( e ) {
        if($('#primeraPantalla').css('display')=='block'){
            loadingSpinner("on");
            window.history.back();
        }else{
            $('#segonaPantalla').css({'display':'none'});
            $('#primeraPantalla').css({'display':'block'});
        }
    },

    loadLink: function ( e ) {
        e.preventDefault();
        var ref = window.open($(e.currentTarget).attr('href'), '_blank', 'location=yes');
    },

    peticioRegistreServer: function ( e ) {
        if($("#formulariLoginClient").valid()){
            $('#usuari2').val($('#usuari').val());
            $('#correu2').val($('#correu').val());
            $('#segonaPantalla').css({'display':'block'});
            $('#primeraPantalla').css({'display':'none'});
        }
    },

    modificarRegistre: function ( e ) {
        $('#segonaPantalla').css({'display':'none'});
        $('#primeraPantalla').css({'display':'block'});
    },

    enviarRegistre: function( e ) {
        e.preventDefault();
        loadingSpinner("on");

        var formData = {};

        $( '#formulariLoginClient div' ).children( 'input' ).each( function( i, el ) {
            if( $( el ).val() != '' )
            {
                formData[ el.id ] = $( el ).val();
            }
        });

        var formUserValues = ({
            usuari: formData['usuari'],
            clau: formData['clau'],
            correu: formData['correu']
        });

        //alert('usuari es: ' + formData['usuari'] + '   clau es: ' + formData['clau']);
        
        var modelUser = new window.User(formUserValues);
        modelUser.url = window.IPServidor + '/api/buonjobs/createuser/';
        modelUser.save( {} , {
            error: function(model, response) {
                loadingSpinner("off");
                customAlert(response.responseText,1,0,"",3,false);
            },
            success: function(model, response) {
                var formUserValues = ({
                    username:  $("#usuari").val(),
                    clau:  $("#clau").val()
                });
                window.localStorage.setItem("auth", JSON.stringify(formUserValues));
                            
                var userURIAPI = "/api/buonjobs/user/"+response.id+"/";
                console.log(userURIAPI);
                
                ///////////////////Ara fer la peticio pel client, ara he fet la del user
                var formClientValues = ({
                    user: userURIAPI,
                    nom: formData['nom'],
                    telefon: formData['telefon'],
                    direccio: ""
                });

                ///alert('nom es: ' + formData['nom'] + 'telefon es: ' + formData['telefon']);

                var modelClient = new window.Client(formClientValues);
                modelClient.url = window.IPServidor + '/api/buonjobs/client/';
                console.log(modelClient);
                modelClient.save( {} , {
                    beforeSend: sendAuthentication,
                    error: function(model, response) {
                        console.log(response);
                    	customAlert(response.responseText,1,0,"",3,false);
                        loadingSpinner("off");
                    },
                    success: function(model, response) {
                        app.navigate('mailClient', {trigger: true, replace: true});
                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Registre - Registre Client", "Click", "Registre Client", 1);
                        }
                    }
                });
            }
        });
    }
});
