window.RegistreProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #boto_registre_client':'peticioRegistreProfesionalServer',
        'click #back_boto':'vesAPantallaAnterior',
        'click #boto_afegir_foto':'getFoto',
        'click #boto_afegir_logo':'canviarBotonsAfegirLogo',
        'click #boto_afegir_foto_certificat':'canviarBotonsAfegirCertificat',
        'click #boto_afegir_fotos':'canviarBotonsAfegirFotos',
        'click #boto_mapa':'addMarkerForAddress',
        'click #boto_categoria':'mostraCategoria',
        'click #categoria':'fixaCategoria',
        'click #refreshMap':'addMarkerForAddress',
        'click #deletePhoto':'eliminaFoto',
        'click #deleteLogo':'eliminaLogo',
        'click #link':'loadLink',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'click #comments3':'comments3',
        'click #comments4':'comments4',

        'click #modificarProposta':'modificarRegistre',
        'click #enviarProposta':'enviarRegistre',
        
    	'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader',

        'click #ampliar':'ampliar'
    },

    ampliar: function(e){
        showImage(e.currentTarget.attributes[1].value);
    },
    
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
   },

    fixaCategoria: function ( e ){
        if(dropdown){
            if($(e.currentTarget).attr('data-categoria')=="reparacions"){
                customAlert('ELECTRICISTAS, FONTANEROS, ALBAÑILES, CARPINTEROS, CERRAJERIA, ELECTRODOMESTICOS, TÉC. ELECTRODOMESTICOS, TV, EBANISTERIA, PINTORES, EMPAPELADORES... Y TODAS LAS ACTIVIDADES RELACIONADAS', 2, 0, '', 0, false, 'Reparaciones/reformas', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="asesorament"){
                customAlert('CONTABILIDAD, FISCAL, LABORAL, LEGAL, ABOGADOS, INGENIEROS, ARQUITECTOS, SEGUROS, COMERCIAL, MARQUETING... Y TODAS LAS ACTIVIDADES DE ASESORAMIENTO Y/O GESTION', 2, 0, '', 0, false, 'asesoramiento/gestión', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="informatica"){
                customAlert('PROGRAMACION, DESARROLLO, MANTENIMIENTO, INSTALACION, SOPORTE, REDES... Y TODAS LAS ACTIVIDADES PROPIAS DE LA INFORMATICA', 2, 0, '', 0, false, 'informática', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="formacio"){
                customAlert('IDIOMAS, MUSICA, COMERCIAL, REFUERZOS DE ASIGNATURAS, VOCAL... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL CONOCIMIENTO', 2, 0, '', 0, false, 'formación', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="arts"){
                customAlert('GRAFICO, PUBLICIDAD, ARQUITECTURA, WEB, INDUSTRIAL, TEATRAL, VIDEO, ACTORES... Y TODAS LAS ACTIVIDADES RELACIONADAS CON EL ARTE Y/O DISEÑO', 2, 0, '', 0, false, 'artes/diseño', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="automocio"){
                customAlert('MECANICA, COMPRA/VENTA... Y TODAS LAS ACTIVIDADES RELACIONADAS CON MOTOS, CAMIONES Y COCHES', 2, 0, '', 0, false, 'automoción', true, e);
            }else if($(e.currentTarget).attr('data-categoria')=="serveis"){
                customAlert('CUIDADO ANCIANOS, LIMPIEZA, CANGUROS, AUPAIRS, JARDINERIA, CUIDADO INFANTIL, MASAJISTAS, FISIOTERAPEUTAS, MONTADORES MOBILIARIO... Y TODAS LAS ACTIVIDADES RELACIONADAS CON LOS SERVICIOS HOGAR', 2, 0, '', 0, false, 'servicios hogar', true, e);
            }
        }else{
            dropdown=true;
            $('#dropdown').animate({height:$('#DropContent').outerHeight()});
            $("#dropButton").attr("src","img/arrow_down.png");
            $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
            $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
        }
    },
    
    loadLink: function ( e ) {
        e.preventDefault();
        var ref = window.open($(e.currentTarget).attr('href'), '_blank', 'location=yes');
    },

    renderSlider: function ( e ) {

        $('#formulariLoginProfesional').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            if($("#formulariLoginProfesional").valid()){
                if(categoria=="undefined"){
                    $('html, body').animate({
                        scrollTop: $('#boto_categoria').offset().top
                    }, 1000);
                    $('#errorVerificarCategoria').css({'display':'block'});
                    loadingSpinner("off");
                }else{
                    if(!booleaGeneral){
                        $('html, body').animate({
                            scrollTop: $('.titleRegistre').offset().top
                        }, 1000);
                        $('#errorVerificarMapa').css({'display':'block'});
                        loadingSpinner("off");
                    }else{
                        $('#usuari2').val($('#usuari').val());
                        $('#correu2').val($('#correu').val());
                        $('#segonaPantalla').css({'display':'block'});
                        $('#primeraPantalla').css({'display':'none'});
                    }
                }
            }
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        uploadFotoLogo=[];
        uploadFoto=[];
        uploadFotoAcred=[];
        timeFotos=1;
        timeAcreditacio=1;
        booleaGeneral=false;
        dropdown=false;
        categoria="undefined";
        //window.deleteFotos = [];
        //window.deleteCertificats = [];

        $("#slider").slider({
            min: 1,
            max: 100,
            value: 20,
            tooltip: 'hide'
        }).on('slide', function(ev){
            $('#distancia').val(ev.value);
        });
        $('#distancia').change( function(){
            $("#slider").slider('setValue', $('#distancia').val());
        });
		//Main Swiper
		swiperDyn = $('#galeria').swiper({
			pagination:'.pagination-sd'
		});
        swiperDynAcred = $('#galeriaAcred').swiper({
            pagination:'.pagination-sdAcred'
        });
        
        //Definim les normes a validar
        $("#formulariLoginProfesional").validate({
            rules: {
                nom: "required",
                usuari: {
                    required: true,
                    minlength: 2
                },
                clau: {
                    required: true,
                    minlength: 5
                },
                clau2: {
                    required: true,
                    minlength: 5,
                    equalTo: "#clau"
                },
                correu: {
                    required: true,
                    email: true
                },
                telefon: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        
        $("#formulariPosicio").validate({
            rules: {
                ciutat: "required",
                carrer: "required",
                codiPostal: {
                    required: true,
                    digits: true
                },
                numero: {
                    required: true,
                    digits: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });
        loadingSpinner("off");
        
      
    },

    eliminaLogo: function ( e ) {
        $('.customAlert').css('width', $(window).width() + 'px', 'important');
        $('.alertMessage').text("Seguro que quieres eliminar el logotipo de profesional?");
                  
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('#contenidorFotoLogo').css({'display':'none'});
                    uploadFotoLogo = [];
                    //window.fotoLogoAPIURL = "";
                    //deleteLogo = true;
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });
    },
  
    eliminaFoto: function ( e ) {
        $('.customAlert').css('width', $(window).width() + 'px', 'important');
        if($(e.currentTarget).attr('data-delete')=="photos"){
            $('.alertMessage').text("Seguro que quieres eliminar la foto de tu trabajo?");
        }
        else{
            $('.alertMessage').text("Seguro que quieres eliminar la foto del certificado?");
        }
            
        $('#alert2').css('display', 'block');

        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                   
                    if($(e.currentTarget).attr('data-delete')=="photos"){
                        timeFotos--;
                        //var urlsplit = window.fotoProfesionalAPIURL[swiperDyn.activeSlide].split("/");
                        //deleteFotos.push(urlsplit[5]);
                        var index = uploadFoto.indexOf(swiperDyn.activeSlide);
                        uploadFoto.splice(index,1);
                        //window.fotoProfesionalAPIURL.splice(index, 1);
                        swiperDyn.prependSlide(swiperDyn.slides[swiperDyn.activeSlide]);
                        swiperDyn.swipeTo(0);
                        swiperDyn.removeSlide(0);
                        if(swiperDyn.slides.length==1){
                            $('.pagination-sd').empty();
                        }
                        if(swiperDyn.slides.length==0){
                            $('#galeria').css({'display':'none'});
                        }
                    }else{
                        timeAcreditacio--;
                        //var urlsplit = window.fotoCertificatAPIURL[swiperDynAcred.activeSlide].split("/");
                        //deleteCertificats.push(urlsplit[5]);
                        var index = uploadFotoAcred.indexOf(swiperDynAcred.activeSlide);
                        uploadFotoAcred.splice(index,1);
                        //window.fotoCertificatAPIURL.splice(index, 1);
                        swiperDynAcred.prependSlide(swiperDynAcred.slides[swiperDynAcred.activeSlide]);
                        swiperDynAcred.swipeTo(0);
                        swiperDynAcred.removeSlide(0);
                        if(swiperDynAcred.slides.length==1){
                            $('.pagination-sdAcred').empty();
                        }
                        if(swiperDynAcred.slides.length==0){
                            $('#galeriaAcred').css({'display':'none'});
                        }
                    }
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                });
            });
        });
        
      
    },

    mostraCategoria: function( e ){
        if(dropdown){
            categoria="undefined";
            dropdown=false;
            $('#dropdown').animate({height:0});
            $("#dropButton").attr("src","img/button_login_cliente.png");
        }else{
            dropdown=true;
            $('#dropdown').animate({height:$('#DropContent').outerHeight()});
            $("#dropButton").attr("src","img/arrow_down.png");
            $("a[data-categoria='reparacions']").text("Reparaciones/reformas");
            $("html, body").animate({ scrollTop: $("#boto_categoria").offset().top }, 1000);
        }
    },

    addMarkerForAddress: function( e ){
        if($("#formulariPosicio").valid()){
            //console.log("Entering addMarkerForAddress()");

            var address = $("#carrer").val() +', '+ $("#numero").val() +', '+ $("#ciutat").val() +', '+ $("#codiPostal").val();

            var latLangForLocation = getLatLangFromAddress(address);
            //console.log("Value returned by getLatLangFromAddress " +latLangForLocation);
        }

        function getLatLangFromAddress(address){
            //console.log("Entering getLatLangFromAddress()");
            var geocoder = new google.maps.Geocoder();
            geocoder.geocode( { 'address': address}, function(results, status) {

                if (status == google.maps.GeocoderStatus.OK) {
                    returnedValue =results[0].geometry.location;
                    console.log("Address found is " + returnedValue);

                    $('#map').css({'display':'block'});
                    $('#wrapperMap').css({'display':'block'});
                    $('.refreshMap').css({'display':'block'});
                    
                    $('#boto_mapa').css({'display':'none'});
                    $('#errorVerificarMapa').css({'display':'none'});

                    //carreguem mapa
                    //console.log("Entering displayCurrentLocation()");
                    try{
                        console.log(returnedValue.lat());
                        var currentLocationLatAndLong = new google.maps.LatLng(returnedValue.lat(),returnedValue.lng());
                        console.log(currentLocationLatAndLong);
                        var mapOptions ={
                            zoom:15,
                            center:currentLocationLatAndLong,
                            mapTypeId: google.maps.MapTypeId.ROADMAP
                        };
                        var mapDiv = document.getElementById("map");
                        map = new google.maps.Map(mapDiv,mapOptions);

                        addMarker(returnedValue);
                        booleaGeneral=true;
                    }catch(e){
                        //console.log("Error occured in ConsultantLocator.displayMap() " + e);
                    }
                    //console.log("Exiting displayCurrentLocation()");
                }else{
                    //alert("Geocode was not successful for the following reason: " + status);
                }
            });
            //console.log("Exiting getLatLangFromAddress()");
        }

        function addMarker(latLng){
            //console.log("Entering addMarker()");
            var markerOptions = new google.maps.Marker({
                map: map,
                position: latLng,
                clickable:true
            });
            var marker = new google.maps.Marker(markerOptions);
            var infoWindowOptions = {
                content: address,
                position: latLng
            };
            var infoWindow = new google.maps.InfoWindow(infoWindowOptions);
            google.maps.event.addListener(marker, "click", function(){
                infoWindow.open(map);
                //console.log("open map");
            });
           //console.log("Exiting addMarker()");
        }
    },

    canviarBotonsAfegirCertificat: function ( e ) {
        $('#boto_afegir_foto_certificat_pressed').css({'display':'block'});
        $('#boto_afegir_foto_certificat').css({'display':'none'});
        $('#boto_afegir_logo_pressed').css({'display':'none'});
        $('#boto_afegir_logo').css({'display':'block'});
        $('#boto_afegir_fotos_pressed').css({'display':'none'});
        $('#boto_afegir_fotos').css({'display':'block'});
        llocFoto = "certificat";
    },

    canviarBotonsAfegirFotos: function ( e ) {
        $('#boto_afegir_fotos_pressed').css({'display':'block'});
        $('#boto_afegir_fotos').css({'display':'none'});
        $('#boto_afegir_foto_certificat_pressed').css({'display':'none'});
        $('#boto_afegir_foto_certificat').css({'display':'block'});
        $('#boto_afegir_logo_pressed').css({'display':'none'});
        $('#boto_afegir_logo').css({'display':'block'});
        llocFoto = "fotos";
    },

    canviarBotonsAfegirLogo: function ( e ) {
        $('#boto_afegir_logo_pressed').css({'display':'block'});
        $('#boto_afegir_logo').css({'display':'none'});
        $('#boto_afegir_foto_certificat_pressed').css({'display':'none'});
        $('#boto_afegir_foto_certificat').css({'display':'block'});
        $('#boto_afegir_fotos_pressed').css({'display':'none'});
        $('#boto_afegir_fotos').css({'display':'block'});
        llocFoto = "logo";
    },

    vesAPantallaAnterior: function ( e ) {
        if($('#primeraPantalla').css('display')=='block'){
            loadingSpinner("on");
            window.history.back();
        }else{
            $('#segonaPantalla').css({'display':'none'});
            $('#primeraPantalla').css({'display':'block'});
        }
    },

    getFoto: function( e ) {
        e.preventDefault();

        if((llocFoto=="fotos" && timeFotos<4) || (llocFoto=="certificat" && timeAcreditacio<4) || (llocFoto=="logo")){

            //amb aquesta variable definim si volem agafar la foto de la galeria o el móbil
            if($(e.currentTarget).attr('data-foto')=="camera"){
                var definedSourceType = navigator.camera.PictureSourceType.CAMERA;
            }else{
                var definedSourceType = navigator.camera.PictureSourceType.PHOTOLIBRARY;
            }

            navigator.camera.getPicture(
                function onPhotoURISuccess(imageURI) {
                    
                    var options = new FileUploadOptions();
                    options.fileKey="file";
                    options.mimeType="image/jpeg";
                    options.chunkedMode=false;
                    var fileName = "" + (new Date()).getTime() + ".jpg"; // consider a more reliable way to generate unique ids
                    options.fileName =fileName;
                  
                 
                    var uploadOptions = [];
                    uploadOptions.push(imageURI);
                    uploadOptions.push(options);

                    if(llocFoto=="logo"){
                        $("#fotoLogo").attr("src",imageURI);
                        $('#contenidorFotoLogo').css({'display':'block'});
                        uploadFotoLogo = uploadOptions;
                        //window.fotoLogoAPIURL = "logosProfessionals/"+options.fileName;
                    }else if(llocFoto=="fotos"){
                        if(timeFotos==1){
                            //alert('borrem fotos');
                            $('#galeria').css({'display':'block'});
                            //window.fotoProfesionalAPIURL = [];
                        }
                        var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+imageURI+'"/>');
                        newSlide.append();

                        uploadFoto.push(uploadOptions);
                        timeFotos++;

                      
                    }else if(llocFoto=="certificat"){
                        if(timeAcreditacio==1){
                            $('#galeriaAcred').css({'display':'block'});
                            //window.fotoCertificatAPIURL = [];
                        }
                        var newSlide = swiperDynAcred.createSlide('<img id="ampliar" src="'+imageURI+'"/>');
                        newSlide.append();

                        uploadFotoAcred.push(uploadOptions);
                        timeAcreditacio++;
                       
                    }
                    
                  
                },
                function onFail(message) {
                    if(message!="Selection cancelled." && message!="Camera cancelled."){
                        //alert('Ocurrió un error: ' + message);
                    }
                },
                { quality: 40, sourceType: definedSourceType, encodingType: Camera.EncodingType.JPEG, targetWidth: 560,targetHeight: 560, correctOrientation: true}
            );
        }
    },

    peticioRegistreProfesionalServer: function ( e ) {
        if($("#formulariLoginProfesional").valid()){
            if(categoria=="undefined"){
                $('html, body').animate({
                    scrollTop: $('#boto_categoria').offset().top
                }, 1000);
                $('#errorVerificarCategoria').css({'display':'block'});
                loadingSpinner("off");
            }else{
                if(!booleaGeneral){
                    $('html, body').animate({
                        scrollTop: $('.titleRegistre').offset().top
                    }, 1000);
                    $('#errorVerificarMapa').css({'display':'block'});
                    loadingSpinner("off");
                }else{
                    $('#usuari2').val($('#usuari').val());
                    $('#correu2').val($('#correu').val());
                    $('#segonaPantalla').css({'display':'block'});
                    $('#primeraPantalla').css({'display':'none'});
                }
            }
        }
    },

    modificarRegistre: function ( e ) {
        $('#segonaPantalla').css({'display':'none'});
        $('#primeraPantalla').css({'display':'block'});
    },

    enviarRegistre: function( e ) {
        e.preventDefault();
        loadingSpinner("on");

        var fotoCertificatAPIURL = [];
        var fotoProfesionalAPIURL = [];
        var fotoLogoAPIURL = "";

     
            var formUserValues = ({
                usuari:  $("#usuari").val(),
                clau:  $("#clau").val(),
                correu:  $("#correu").val()
            });

            var modelUser = new window.User(formUserValues);
            modelUser.url = window.IPServidor + '/api/buonjobs/createuser/';

            modelUser.save( {} , {
                error: function(model, response) {
                	customAlert(response.responseText,1,0,"",3,false);
                    loadingSpinner("off");
                },
                success: function(model, response) {

                    var userURIAPI = "/api/buonjobs/user/"+response.id+"/";

                    var formUserValues = ({
                        username:  $("#usuari").val(),
                        clau:  $("#clau").val()
                    });
                    window.localStorage.setItem("auth", JSON.stringify(formUserValues));

                
                    var fotosPujar = 0;
                    fotosPujar+=uploadFoto.length;
                    fotosPujar+=uploadFotoAcred.length;

                    //alert("uploadFotoLogo");
                    //alert(uploadFotoLogo.length);
                    if(uploadFotoLogo.length>0){
                        fotosPujar++;
                        //alert("entroUploadLogo");
                        uploadFotoRegistre(1,uploadFotoLogo[0],uploadFotoLogo[1]);
                    }else{
                        if(fotosPujar==0){
                            pujaResta();
                        }else if(uploadFotoAcred.length>0){
                            for(var i=0; i<uploadFotoAcred.length; i++){
                                uploadFotoRegistre(3,uploadFotoAcred[i][0],uploadFotoAcred[i][1]);
                            }
                        }else{
                            for(var i=0; i<uploadFoto.length; i++){
                                //alert(JSON.stringify(uploadFoto[i][1]));
                                uploadFotoRegistre(2,uploadFoto[i][0],uploadFoto[i][1]);
                            }
                        }
                    }
                    //alert("uploadFotoAcred");
                    //alert(uploadFotoAcred.length);
                    for(var i=0; i<uploadFotoAcred.length; i++){
                        uploadFotoRegistre(3,uploadFotoAcred[i][0],uploadFotoAcred[i][1]);
                    }
                    for(var j=0; j<uploadFoto.length; j++){
                        uploadFotoRegistre(2,uploadFoto[j][0],uploadFoto[j][1]);
                    }

                    function uploadFotoRegistre (tipus, imageURI, options){

                        var tries = 0;
                        var ft = new FileTransfer();
                        //loadingSpinner("on");
                        
                        var signingURI = window.IPServidor+ "/signing";
	                    
                        $.ajax({url: signingURI, dataType: "json", type: "GET"})
                        .done(function (data) {
        	        	
        	        	    options.params = {
        	                    "key":  options.fileName,
        	                    "AWSAccessKeyId": data.awsKey,
        	                    "acl": "public-read",
        	                    "policy": data.policy,
        	                    "signature": data.signature,
        	                    "Content-Type": "image/jpeg"
        	                };
        	                
                       	    ft.upload(imageURI, s3URI, win, fail, options, false);
                        })
                        .fail(function (error) {
                        	customAlert("Ha fallado la connexión con el servidor. Intentalo de nuevo.",0,2000,"",3,false);
                            loadingSpinner("off");
                        });
                        
                        //ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, false);
                        //alert(imageURI);
                        //alert(window.IPServidor + "/uploadImage");
                        //alert(JSON.stringify(options));
                        
                        //ft.upload(imageURI, s3URI, win, fail, options, true);

                        function win(r) {
                          
                            if(tipus==1){
                                //fotoLogoAPIURL = "logosProfessionals/"+options.fileName;
                            	fotoLogoAPIURL = options.fileName;
                                //alert(fotoLogoAPIURL);
                                fotosPujar--;
                                if(fotosPujar==0){
                                    pujaResta();
                                }/*else{
                                    for(var i=0; i<uploadFotoAcred.length; i++){
                                        uploadFotoRegistre(3,uploadFotoAcred[i][0],uploadFotoAcred[i][1]);
                                    }
                                }*/
                            }else if(tipus==2){
                                //alert("inside");
                                var fotoProfesionalValues = ({
                                    //imatges: "fotosProfessionals/"+options.fileName
                                	imatges: options.fileName
                                });

                                var modelProfesionalFoto = new window.FotoProfesional(fotoProfesionalValues);
                                modelProfesionalFoto.url = window.IPServidor + "/api/buonjobs/fotoProfesional/";
                                modelProfesionalFoto.save( {} , {
                                    beforeSend: sendAuthentication,
                                    error: function(model, response) {
                                        customAlert(response.responseText,0,3000,"",3,false);
                                        loadingSpinner("off");
                                    },
                                    success: function(model, response) {
                                        //alert(response['resource_uri']);
                                        //timeFotos++;
                                        fotoProfesionalAPIURL.push(response['resource_uri']);
                                        fotosPujar--;
                                        if(fotosPujar==0){
                                            pujaResta();
                                        }
                                    }
                                });
                            }else if(tipus==3){
                                var certificatProfesionalValues = ({
                                    acreditacionsProfesionals: options.fileName
                                    //acreditacionsProfesionals: "acreditacionsProfessionals/"+options.fileName
                                });

                                var modelProfesionalCertificat = new window.AcreditacioProfesional(certificatProfesionalValues);
                                modelProfesionalCertificat.url = window.IPServidor + "/api/buonjobs/acreditacioProfesional/";
                                modelProfesionalCertificat.save( {} , {
                                    beforeSend: sendAuthentication,
                                    error: function(model, response) {
                                        customAlert(response.responseText,0,3000,"",3,false);
                                        loadingSpinner("off");
                                    },
                                    success: function(model, response) {
                                        //alert(response['resource_uri']);
                                        //timeAcreditacio++;
                                        //alert(fotoCertificatAPIURL.length);
                                        fotoCertificatAPIURL.push(response['resource_uri']);
                                        //alert(fotoCertificatAPIURL);
                                        fotosPujar--;
                                        //alert(fotosPujar);
                                        if(fotosPujar==0){
                                            pujaResta();
                                        }/*else if(fotosPujar==uploadFoto.length){
                                            for(var i=0; i<uploadFoto.length; i++){
                                                alert(JSON.stringify(uploadFoto[i][1]));
                                                uploadFotoRegistre(2,uploadFoto[i][0],uploadFoto[i][1]);
                                            }
                                        }*/
                                    }
                                });
                            }
                        }
                        function fail(error) {
                            //alert(tries);
                            if(tries<3){
                                tries++;
                                //alert("tries: "+tries);
                                ft.upload(imageURI, window.IPServidor + "/uploadImage", win, fail, options, true);
                            }else{
                                customAlert("Se ha producido un error subiendo la imagen",0,3000,"",3,false);
                                loadingSpinner("off");
                                //alert("An error has occurred: Code = " + error.code +", Source = " + error.source +", Target = " + error.target);
                            }
                        }
                    }

                    function pujaResta(){

                        var direccioValues = ({
                            numero: $("#numero").val(),
                            carrer: $("#carrer").val(),
                            ciutat: $("#ciutat").val(),
                            codipostal: $("#codiPostal").val(),
                            latitud: returnedValue.lat(),
                            longitud: returnedValue.lng()
                        });

                        //alert("abans direccio");
                        //alert(JSON.stringify(direccioValues));

                        var modelDireccio = new window.Direccio(direccioValues);
                        modelDireccio.url = window.IPServidor + '/api/buonjobs/direccio/';
                        //alert(JSON.stringify(modelDireccio));
                        modelDireccio.save( {} , {
                            beforeSend: sendAuthentication,
                            error: function(model, response) {
                                //alert("error direccio");
                                //alert(JSON.stringify(response));
                                customAlert(response.responseText,1,0,"",3,false);
                                loadingSpinner("off");
                            },
                            success: function(model, response) {
                                //alert("direccio");
                                var direccioAPIURL = response.resource_uri;
                                
                                var formProfesionalValues = ({
                                    user: userURIAPI,
                                    nom: $("#nom").val(),
                                    telefon: $("#telefon").val(),
                                    empresa:  $("#empresa").val(),
                                    activitat: categoria,
                                    descripcio: $("#descripcio").val(),
                                    logotip: fotoLogoAPIURL,
                                    direccio: direccioAPIURL,
                                    acreditacions: fotoCertificatAPIURL,
                                    imatges: fotoProfesionalAPIURL,
                                    cif: $("#CIF").val(),
                                    distanciaTreballs: $("#distancia").val()
                                });

                                var modelProfesional = new window.Profesional(formProfesionalValues);
                                modelProfesional.url = window.IPServidor + '/api/buonjobs/profesional/';
                                //alert(JSON.stringify(modelProfesional));
                                modelProfesional.save( {} , {
                                    beforeSend: sendAuthentication,
                                    error: function(model, response) {
                                        //alert(JSON.stringify(response));
                                        //alert("error profesional");
                                        customAlert(response.responseText,1,0,"",3,false);
                                        loadingSpinner("off");
                                    },
                                    success: function(model, response) {
                                        app.navigate('mailProfesional', {trigger: true, replace: true});
                                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Registre - Registre Professional", "Click", "Registre Professional", 1);
                                        }
                                    }
                                });
                            }
                        });
                    }
                }
            });
        //}
    },

    comments1: function( e ) {
        customAlert("si tienes documentos de alta en autónomos y seguro de responsabilidad de civil o si cuentas con otros documentos que acrediten que eres un buen profesional, la pertenencia a un Gremio Oficial o colegio, puedes conseguir un mejor resultado en Bu:on Jobs. Es importante saber que los clientes podran ver estos certificados de garantia en tus propuestas!!!",1,0,"",3,false);
    },

    comments2: function( e ) {
        customAlert("puedes subir fotos de tus anteriores trabajos para causar mejor impresión cuando presentes tu candidatura para un trabajo",1,0,"",3,false);
    },

    comments3: function( e ) {
        customAlert("puedes describir el trabajo que haces o como lo haces, cuanto más completo mejor!",1,0,"",3,false);
    },

    comments4: function( e ) {
        customAlert("especifica el radio de quilómetros hasta el que quieres recibir ofertas de los clientes",1,0,"",3,false);
    }
    
   

});