window.OfertaLlistatView = Backbone.View.extend({

    initialize: function () {
        this.render();
    
    },
    render:function (eventName) {

        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #oferta':'vesSeguentPantalla'
    },

    renderSlider: function ( e ) {
        
        var content = $('ul');
        var desDaqui = window.localStorage.getItem("desDaqui");

        if(desDaqui=="true"){
            var url =  window.IPServidor + '/api/buonjobs/oferta/?longitud=' + window.localStorage.getItem("longitud") + '&latitud=' + window.localStorage.getItem("latitud") + '&radi=' + window.localStorage.getItem("radi");
        }else{
            var url =  window.IPServidor + '/api/buonjobs/oferta/';
        }

        $.ajax({
            url: url,
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {

                var notificacions = JSON.parse(window.localStorage.getItem("notifications"));
                var quantesOfertes = missatgeResposta.objects.length;
                var fotoOferta = "";
                
                for(var i=0;i<quantesOfertes;i++) {
                    //alert(missatgeResposta.objects[i].caducitatOferta);
                    if(missatgeResposta.objects[i].caducitatOferta != 'oferta caducada')
                    {
                        if(missatgeResposta.objects[i].imatges.length>0){
                            fotoOferta = missatgeResposta.objects[i].imatges[0].imatgeOferta;
                           
                        }else{
                            fotoOferta = "img/default_image.png";
                        }                    
                        var valuesOfertaLlistatModel = ({
                            id: missatgeResposta.objects[i].id,
                            resum: missatgeResposta.objects[i].resum,
                            caduca: missatgeResposta.objects[i].caducitatOferta,
                            ciutat: missatgeResposta.objects[i].direccio['ciutat'],
                            foto: fotoOferta
                        });

                        var modelAux = new OfertaModelLlistat(valuesOfertaLlistatModel);

                        content.append(new OfertaLlistatItemView({model: modelAux}).render().el);
                        if(notificacions!=null){
                        	var result = $.grep(notificacions.data, function(e){ 
                            	return (e.idNotificacio == missatgeResposta.objects[i].id && e.messageType == 5); 
                            });
                           
                            if(result.length!=0){
                            	
                            	$('[data-oferta=' + missatgeResposta.objects[i].id + ']').removeClass('baseBackground');
                                $('[data-oferta=' + missatgeResposta.objects[i].id + ']').addClass('listSelected');
                            }
                            
                        }
                    }
                   
                }
                if(notificacions!=null){
                    window.localStorage.setItem("notifications", JSON.stringify(notificacions));
                }

                $('.btnHover').on('touchstart', function(e){
                    $(this).addClass('tapped');
                });
                $('.btnHover').on('touchend', function(e){
                    setTimeout(function(){
                        $('.btnHover').removeClass('tapped');
                    }, 200);
                });
                
                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat ofertes fail");
                loadingSpinner("off");
            }
        });
    },

    vesSeguentPantalla: function ( e ) {
        loadingSpinner("on");
        var oferta = $(e.currentTarget).attr('data-oferta');
        var urlLoginClientRecurs = window.IPServidor + '/api/buonjobs/oferta/'+oferta+'/';
        
        var modelOferta = new window.Oferta();
        modelOferta.url = urlLoginClientRecurs;
        modelOferta.fetch({
            beforeSend: sendAuthentication,
            error: function () {
                //alert("error al cargar la oferta");
                loadingSpinner("off");
            },
            success: function (model, response) {
                var notificacions = JSON.parse(window.localStorage.getItem("notifications"));

                if(notificacions!=null){
                	
                	var result = $.grep(notificacions.data, function(e)
                    { 
                    	return (e.idNotificacio == model.attributes.id && e.messageType == 5); 
                    });
                    ////////////////////////////////////console.log(result);
                    if(result.length!=0){
                        var index = notificacions.data.indexOf(result);
                        notificacions.data.splice(index, 1);
                        $.ajax({
                            url: window.IPServidor + '/api/buonjobs/notificacio/'+result[0].id+'/',
                            type:'DELETE',
                            dataType:'json',
                            beforeSend: sendAuthentication,
                            contentType:'application/json',
                            success:function (missatgeResposta) {
                                window.localStorage.setItem("notifications",JSON.stringify(notificacions));
                            },
                            error: function (errormessage) {
                                //alert("error");
                            }
                        });
                    }
                }
                window.localStorage.setItem("offer", JSON.stringify(model));
                app.navigate("ofertaProfesional", true);
            }
        });
    },
   

    vesAPantallaAnterior: function ( e ) {
        //////////////////////////////////console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    }
});

window.OfertaLlistatItemView = Backbone.View.extend({

    tagName:"li",

    initialize: function () {},

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        return this;
    }
});

